#include <allegro.h>
#include "pm.h"

extern BITMAP *memory_bitmap[NUM_SPRITES];
extern BITMAP *level_2000, *scrn_buffer;
extern BITMAP *map100_bmp, *map100_bkg;

extern int l[100][100];    // level
extern int item[500][16];  // items
extern float itemf[500][4];
extern int Ei[100][32];    // enemies
extern float Ef[100][16];  // enemies
extern int zz[20][NUM_ANS];

extern int max_bullets;
extern int pbullet[50][6];
extern int pm_bullet_collision_box;

extern int e_bullet_active[50], e_bullet_shape[50];
extern int enemy_bullet_colision_window;
extern float e_bullet_x[50], e_bullet_y[50], e_bullet_xinc[50], e_bullet_yinc[50];

//extern int num_enemy;
extern int game_map_on;
extern int map_empty_color, map_bullet_color;

void proc_pbullets()
{
   int b,d,p,x,y;
   // fire new player bullet
   for (p=0; p<NUM_PLAYERS; p++)
      if ((players[p].active) && (!players[p].paused))
      {
         if (players[p].fire)
         {
            if (players[p].fire_held == 0) // fire button pressed and not held
            {
               players[p].fire_held = 1;
               if ((players[p].num_bullets > 0) && (players[p].bullet_wait_counter < 1 ))
               {
                  // search for empty bullet
                  for (b=0; b<50; b++)
                     if (!pbullet[b][0])
                     {
                        event(1);
                        pbullet[b][0] = 1;
                        pbullet[b][1] = p;
                        pbullet[b][2] = players[p].PXint ;
                        pbullet[b][3] = players[p].PYint + 1;
                        pbullet[b][4] = 0; // xinc
                        pbullet[b][5] = 0; // yinc
                        players[p].num_bullets--;
                        if (players[p].up)
                        {
                           pbullet[b][5] = -players[p].bullet_speed;
                           pbullet[b][2] = -5 + players[p].PXint  + (players[p].left_right*10);
                        }
                        else if (players[p].down)
                        {
                           pbullet[b][5] = players[p].bullet_speed;
                           pbullet[b][2] = -5 + players[p].PXint  + (players[p].left_right*10);
                        }
                        else
                        {
                           pbullet[b][4] = (players[p].left_right * (players[p].bullet_speed*2) ) - players[p].bullet_speed;
                        }
                        players[p].bullet_wait_counter = players[p].bullet_wait;
                        players[p].fire_held = 1;
                        break;
                     }
               }
               else event(20); // out of bullets

            }
         }
         else // fire is not pressed
         {

            players[p].fire_held = 0;
         }

         if (players[p].bullet_wait_counter > 0)
         {
            players[p].bullet_wait_counter--;
         }



      }



   // move and process wall collision
   for (b = 0; b < 50; b++)
   {
      if (pbullet[b][0])  // if bullet not active skip to next one
      {
         pbullet[b][2] += pbullet[b][4];  // xinc
         pbullet[b][3] += pbullet[b][5];  // yinc
         if ((pbullet[b][2] < 5) || (pbullet[b][2] > 1995) || (pbullet[b][3]<5) || (pbullet[b][3] > 1995) )
            pbullet[b][0] = 0;
         x = ( (pbullet[b][2] + 10) / 20);
         y = ( (pbullet[b][3] + 10) / 20);
         d = l[x][y];
         if ((d > 63) && (d < NUM_SPRITES)) // if hit solid or breakable
         {
            pbullet[b][0] = 0;  // bullet dies
            if ((d > 95) && (d < 128)) // breakable wall
            {
               l[x][y] = 0; // wall dies too
               blit(memory_bitmap[0], level_2000, 0, 0, (x*20), (y*20), 20, 20);
               putpixel(map100_bkg, x, y, map_empty_color);
            }
         }
      }
   }
}

void draw_pbullets()
{
   int b, p, x, y;
   for (b = 0; b < 50; b++)
      if (pbullet[b][0])  // if bullet not active skip to next one
      {
         x = ( (pbullet[b][2] + 10) / 20);
         y = ( (pbullet[b][3] + 10) / 20);
         for (p=0; p<NUM_PLAYERS; p++)
            if ((players[p].active) && (!players[p].paused))
            {
               set_clip(scrn_buffer, players[p].SX, players[p].SY, players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);
               int AX = players[p].SX+pbullet[b][2]-players[p].WX;
               int AY = players[p].SY+pbullet[b][3]-players[p].WY;
               draw_sprite(scrn_buffer, memory_bitmap[zz[0][64+pbullet[b][1]]], AX, AY);
            }
         set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
         if (game_map_on) putpixel(map100_bmp, x, y, map_bullet_color);
      }
}

void proc_ebullets()
{
   int b,d,x,y;
   for (b = 0; b < 50; b++)
      if (e_bullet_active[b])  // if bullet not active skip to next one
      {
         int p, ex, ey;
         e_bullet_x[b] += e_bullet_xinc[b]; // inc x
         e_bullet_y[b] += e_bullet_yinc[b]; // inc y
         ex = (int)e_bullet_x[b];
         ey = (int)e_bullet_y[b];
         if ((ex<0) || (ex>2000) || (ey<0) || (ey>2000))
            e_bullet_active[b] = 0;
         x = (ex+10)/20;
         y = (ey+10)/20;
         d = l[x][y];
         if ((d > 63) && (d<NUM_SPRITES))  // bullet hit solid or breakable wall
         {
            e_bullet_active[b] = 0;        // bullet dies
            if ((d > 95) && (d < 128))     // remove breakable wall
            {
               l[x][y] = 0;
               blit(memory_bitmap[0], level_2000, 0, 0, (x*20), (y*20), 20, 20);
               putpixel(map100_bkg, x, y, map_empty_color);
            }
         }
         if (game_map_on) putpixel(map100_bmp, x, y, map_bullet_color);

         // check for collision with players
         for (p=0; p<NUM_PLAYERS; p++)
            if ((players[p].active) && (!players[p].paused))
               if (ex > (players[p].PXint  - enemy_bullet_colision_window ))
                  if (ex < (players[p].PXint  + enemy_bullet_colision_window ))
                     if (ey > (players[p].PYint - enemy_bullet_colision_window ))
                        if (ey < (players[p].PYint + enemy_bullet_colision_window ))
                        {  // player got hit!
                           switch (e_bullet_shape[b])
                           {
                              case 488:   players[p].LIFE -= 5;  break; // arrow
                              case 489:   players[p].LIFE -= 5;  break; // arrow
                              case 1055:  players[p].LIFE -= 7;  break; // cannon ball
                              case 1020:  players[p].LIFE -= 9;  break; // yellow things
                              case 1054:  players[p].LIFE -= 10; break; // green ball
                              case 1062:  players[p].LIFE -= 8;  break; // flapper thing
                           }
                           event(11);
                           e_bullet_active[b] = 0;
                        }
      }
}

void draw_ebullets()
{
   int b, d, p;
   for (b = 0; b < 50; b++)
      if (e_bullet_active[b])  // if bullet not active skip to next one
      {
         int ex = (int)e_bullet_x[b];
         int ey = (int)e_bullet_y[b];
         for (p=0; p<NUM_PLAYERS; p++)
            if ((players[p].active) && (!players[p].paused))
            {
               set_clip(scrn_buffer, players[p].SX, players[p].SY, players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);
               if (e_bullet_shape[b] > 1000)
               {
                  d =  e_bullet_shape[b]-1000;
                  d = zz[0][d];
                  draw_sprite(scrn_buffer, memory_bitmap[d], players[p].SX+ex-players[p].WX, players[p].SY+ey-players[p].WY);
               }
               else draw_sprite(scrn_buffer, memory_bitmap[e_bullet_shape[b]], players[p].SX+ex-players[p].WX, players[p].SY+ey-players[p].WY);
               set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
            }
      }
}

