#include "pm.h"

#ifdef NETPLAY
#include "server.h"
#include "client.h"
#include "packet.h"
char serveraddress[256] = "192.168.0.5";
#endif

extern int control_lead_frames;

void client_control(int);
void server_control(int);

void inc_timer_passcount(void);

extern char global_string[20][25][80]; // menu.c

extern int passcount_timer_fps;

extern int resume_allowed;
extern int game_exit;
extern int passcount;

void set_passcount_timer_fps(int x);


//extern volatile int timer_passcount = 0;

char *key_names[] =
{
   "(none)",     "A",          "B",          "C",
   "D",          "E",          "F",          "G",
   "H",          "I",          "J",          "K",
   "L",          "M",          "N",          "O",
   "P",          "Q",          "R",          "S",
   "T",          "U",          "V",          "W",
   "X",          "Y",          "Z",          "0",
   "1",          "2",          "3",          "4",
   "5",          "6",          "7",          "8",
   "9",          "0_PAD",      "1_PAD",      "2_PAD",
   "3_PAD",      "4_PAD",      "5_PAD",      "6_PAD",
   "7_PAD",      "8_PAD",      "9_PAD",      "F1",
   "F2",         "F3",         "F4",         "F5",
   "F6",         "F7",         "F8",         "F9",
   "F10",        "F11",        "F12",        "ESC",
   "TILDE",      "MINUS",      "EQUALS",     "BACKSPACE",
   "TAB",        "OPENBRACE",  "CLOSEBRACE", "ENTER",
   "COLON",      "QUOTE",      "BACKSLASH",  "BACKSLASH2",
   "COMMA",      "STOP",       "SLASH",      "SPACE",
   "INSERT",     "DEL",        "HOME",       "END",
   "PGUP",       "PGDN",       "LEFT",       "RIGHT",
   "UP",         "DOWN",       "SLASH_PAD",  "ASTERISK",
   "MINUS_PAD",  "PLUS_PAD",   "DEL_PAD",    "ENTER_PAD",
   "PRTSCR",     "PAUSE",      "ABNT_C1",    "YEN",
   "KANA",       "CONVERT",    "NOCONVERT",  "AT",
   "CIRCUMFLEX", "COLON2",     "KANJI",
   "LSHIFT",     "RSHIFT",     "LCONTROL",   "RCONTROL",
   "ALT",        "ALTGR",      "LWIN",       "RWIN",
   "MENU",       "SCRLOCK",    "NUMLOCK",    "CAPSLOCK",

   "MAX",               "",            "",           "",       "",

   // joystick equivalents
   // 120-
           "joy1-up","joy1-down","joy1-left","joy1-right",
           "joy1-b0","joy1-b1","joy1-b2","joy1-b3",
           "joy1-b4","joy1-b5","joy1-b6","joy1-b7",
   // 132-
           "joy2-up","joy2-down","joy2-left","joy2-right",
           "joy2-b0","joy2-b1","joy2-b2","joy2-b3",
           "joy2-b4","joy2-b5","joy2-b6","joy2-b7",

};


void clear_keys(int p)
{
   players[p].left = 0;
   players[p].right = 0;
   players[p].up = 0;
   players[p].down = 0;
   players[p].jump = 0;
   players[p].fire = 0;
}


void press_any()
{
   clear_keybuf();
   if (0) // joystick control
   {
      do
      {
         poll_joystick();
      } while ((joy_b1) || (joy_b2));  // wait for release first, if still pressed on entry
      do
      {
         poll_joystick();
      } while ((!joy_b1) && (!keypressed()) && (!joy_b2));  // wait for press
   }
   else readkey();
}

int press_any_p_rt(int p)
{
   // this function will return a zero all the time unless the player has pressed a control
   int ret = 0;

   poll_joystick();
   //  check for up
   if (players[p].up_key > 119) players[p].up = joy_check(players[p].up_key);
   else if (key[players[p].up_key]) players[p].up = 1;
   if (players[p].up) ret = 1;

   //  check for down
   if (players[p].down_key > 119) players[p].down = joy_check(players[p].down_key);
   else if (key[players[p].down_key]) players[p].down = 1;
   if (players[p].down) ret = 1;

   //  check for left
   if (players[p].left_key > 119) players[p].left = joy_check(players[p].left_key);
   else if (key[players[p].left_key]) players[p].left = 1;
   if (players[p].left) ret = 1;

   //  check for right
   if (players[p].right_key > 119) players[p].right = joy_check(players[p].right_key);
   else if (key[players[p].right_key]) players[p].right = 1;
   if (players[p].right) ret = 1;

   //  check for fire
   if (players[p].fire_key > 119) players[p].fire = joy_check(players[p].fire_key);
   else if (key[players[p].fire_key]) players[p].fire = 1;
   if (players[p].fire) ret = 1;

   //  check for jump
   if (players[p].jump_key > 119) players[p].jump = joy_check(players[p].jump_key);
   else if (key[players[p].jump_key]) players[p].jump = 1;
   if (players[p].jump) ret = 1;

   return ret;
}


int my_readkey(void)
{
   textout_centre(screen, font, "...press new key or joystick control...", SCREEN_W/2, SCREEN_H/2, 10);
   int c, quit = 0, ret = 0;
   while (!quit)
   {
      int j;
      for (j=0; j<num_joysticks; j++)
      {
         if (joy[j].flags & JOYFLAG_DIGITAL) // if joy stick present
         {
             poll_joystick();   // read joystick
             for (c=0; c<joy[j].num_buttons; c++) // cycle buttons
             {
                if (joy[j].button[c].b) // button pressed
                {
                   while (joy[j].button[c].b) poll_joystick(); // wait for release
                   ret = 124+c+(j*12);
                   quit = 1;
                }
             }
             if (joy[j].stick[0].axis[1].d1) // up
             {
                 while (joy[j].stick[0].axis[1].d1) poll_joystick(); // wait for release
                 ret = 120+(j*12);
                 quit = 1;
             }
             if (joy[j].stick[0].axis[1].d2) // down
             {
                 while (joy[j].stick[0].axis[1].d2) poll_joystick(); // wait for release
                 ret = 121+(j*12);
                 quit = 1;
             }
             if (joy[j].stick[0].axis[0].d1) // left
             {
                 while (joy[j].stick[0].axis[0].d1) poll_joystick(); // wait for release
                 ret = 122+(j*12);
                 quit = 1;
             }
             if (joy[j].stick[0].axis[0].d2) // right
             {
                 while (joy[j].stick[0].axis[0].d2) poll_joystick(); // wait for release
                 ret = 123+(j*12);
                 quit = 1;
             }
         }
      }
      for (c=0; c<128; c++)
      {
         if ((key[c]) && (!key[KEY_ENTER])) // don't let <ENTER> be one of the controls
         {
            while (key[c]); // wait for release
            ret = c;
            quit = 1;
         }
      }
   }
   textout_centre(screen, font, "                                        ", SCREEN_W/2, SCREEN_H/2, 10);
   return ret;
}


void load_keys()
{
   players[0].up_key    = get_config_int("GAMECONTROLS", "p1_up_key",    KEY_UP);
   players[0].down_key  = get_config_int("GAMECONTROLS", "p1_down_key",  KEY_DOWN);
   players[0].right_key = get_config_int("GAMECONTROLS", "p1_right_key", KEY_RIGHT);
   players[0].left_key  = get_config_int("GAMECONTROLS", "p1_left_key",  KEY_LEFT);
   players[0].jump_key  = get_config_int("GAMECONTROLS", "p1_jump_key",  KEY_SPACE);
   players[0].fire_key  = get_config_int("GAMECONTROLS", "p1_fire_key",  KEY_C);
   players[0].map_key   = get_config_int("GAMECONTROLS", "p1_map_key",   KEY_M);
   players[0].menu_key  = get_config_int("GAMECONTROLS", "p1_menu_key",  KEY_ESC);

   players[1].up_key    = get_config_int("GAMECONTROLS", "p2_up_key",    KEY_R);
   players[1].down_key  = get_config_int("GAMECONTROLS", "p2_down_key",  KEY_F);
   players[1].right_key = get_config_int("GAMECONTROLS", "p2_right_key", KEY_G);
   players[1].left_key  = get_config_int("GAMECONTROLS", "p2_left_key",  KEY_D);
   players[1].jump_key  = get_config_int("GAMECONTROLS", "p2_jump_key",  KEY_A);
   players[1].fire_key  = get_config_int("GAMECONTROLS", "p2_fire_key",  KEY_Q);
   players[1].map_key   = get_config_int("GAMECONTROLS", "p2_map_key",   KEY_M);
   players[1].menu_key  = get_config_int("GAMECONTROLS", "p2_menu_key",  KEY_ESC);
}
void save_keys()
{
   set_config_int("GAMECONTROLS", "p1_up_key",    players[0].up_key);
   set_config_int("GAMECONTROLS", "p1_down_key",  players[0].down_key);
   set_config_int("GAMECONTROLS", "p1_right_key", players[0].right_key);
   set_config_int("GAMECONTROLS", "p1_left_key",  players[0].left_key);
   set_config_int("GAMECONTROLS", "p1_jump_key",  players[0].jump_key);
   set_config_int("GAMECONTROLS", "p1_fire_key",  players[0].fire_key);
   set_config_int("GAMECONTROLS", "p1_map_key",   players[0].map_key);
   set_config_int("GAMECONTROLS", "p1_menu_key",  players[0].menu_key);

   set_config_int("GAMECONTROLS", "p2_up_key",    players[1].up_key);
   set_config_int("GAMECONTROLS", "p2_down_key",  players[1].down_key);
   set_config_int("GAMECONTROLS", "p2_right_key", players[1].right_key);
   set_config_int("GAMECONTROLS", "p2_left_key",  players[1].left_key);
   set_config_int("GAMECONTROLS", "p2_jump_key",  players[1].jump_key);
   set_config_int("GAMECONTROLS", "p2_fire_key",  players[1].fire_key);
   set_config_int("GAMECONTROLS", "p2_map_key",   players[1].map_key);
   set_config_int("GAMECONTROLS", "p2_menu_key",  players[1].menu_key);
}

void get_all_keys(int p)
// prompts for all eight keys in arow
{
   int a, key_sel;
   clear(screen);
   clear_keybuf();
   rest(100);

   sprintf(global_string[5][ 2], "   player %d - Up ----- %s", p+1, key_names[ players[p].up_key]);
   sprintf(global_string[5][ 3], "   player %d - Down --- %s", p+1, key_names[ players[p].down_key]);
   sprintf(global_string[5][ 4], "   player %d - Right -- %s", p+1, key_names[ players[p].right_key]);
   sprintf(global_string[5][ 5], "   player %d - Left --- %s", p+1, key_names[ players[p].left_key]);
   sprintf(global_string[5][ 6], "   player %d - Jump --- %s", p+1, key_names[ players[p].jump_key]);
   sprintf(global_string[5][ 7], "   player %d - Fire --- %s", p+1, key_names[ players[p].fire_key]);
   sprintf(global_string[5][ 8], "   player %d - Map ---- %s", p+1, key_names[ players[p].map_key]);
   sprintf(global_string[5][ 9], "   player %d - Menu --- %s", p+1, key_names[ players[p].menu_key]);

   for (a=2; a<10; a++)
      while (strlen(global_string[5][a]) < 38)
         strcat(global_string[5][a], " "); // pad string length

   //   key_sel = zmenu(5, key_sel, 50);

   for (key_sel = 2; key_sel < 10; key_sel++)
   {
      textout(screen, font, global_string[5][key_sel], 40, 100+8*key_sel,10);
      switch (key_sel)
      {
         case  2: players[p].up_key    =  my_readkey(); break;
         case  3: players[p].down_key  =  my_readkey(); break;
         case  4: players[p].right_key =  my_readkey(); break;
         case  5: players[p].left_key  =  my_readkey(); break;
         case  6: players[p].jump_key  =  my_readkey(); break;
         case  7: players[p].fire_key  =  my_readkey(); break;
         case  8: players[p].map_key   =  my_readkey(); break;
         case  9: players[p].menu_key  =  my_readkey(); break;
      }
      sprintf(global_string[5][ 2], "   player %d - Up ----- %s", p+1, key_names[ players[p].up_key]);
      sprintf(global_string[5][ 3], "   player %d - Down --- %s", p+1, key_names[ players[p].down_key]);
      sprintf(global_string[5][ 4], "   player %d - Right -- %s", p+1, key_names[ players[p].right_key]);
      sprintf(global_string[5][ 5], "   player %d - Left --- %s", p+1, key_names[ players[p].left_key]);
      sprintf(global_string[5][ 6], "   player %d - Jump --- %s", p+1, key_names[ players[p].jump_key]);
      sprintf(global_string[5][ 7], "   player %d - Fire --- %s", p+1, key_names[ players[p].fire_key]);
      sprintf(global_string[5][ 8], "   player %d - Map ---- %s", p+1, key_names[ players[p].map_key]);
      sprintf(global_string[5][ 9], "   player %d - Menu --- %s", p+1, key_names[ players[p].menu_key]);
      textout(screen, font, global_string[5][key_sel], 40, 100+8*key_sel,9);
   }
   save_keys();
   clear(screen);
}

void get_one_key(int p)
{
   int a, key_sel;
   clear(screen);
   clear_keybuf();
   do
   {
      sprintf(global_string[5][ 2], "  Return to Main Menu  " );
      sprintf(global_string[5][ 3], "--------------------------" );
      sprintf(global_string[5][ 4], "  player %d - Up ----- %s", p+1, key_names[ players[p].up_key]);
      sprintf(global_string[5][ 5], "  player %d - Down --- %s", p+1, key_names[ players[p].down_key]);
      sprintf(global_string[5][ 6], "  player %d - Right -- %s", p+1, key_names[ players[p].right_key]);
      sprintf(global_string[5][ 7], "  player %d - Left --- %s", p+1, key_names[ players[p].left_key]);
      sprintf(global_string[5][ 8], "  player %d - Jump --- %s", p+1, key_names[ players[p].jump_key]);
      sprintf(global_string[5][ 9], "  player %d - Fire --- %s", p+1, key_names[ players[p].fire_key]);
      sprintf(global_string[5][10], "  player %d - Map ---- %s", p+1, key_names[ players[p].map_key]);
      sprintf(global_string[5][11], "  player %d - Menu --- %s", p+1, key_names[ players[p].menu_key]);
      sprintf(global_string[5][12], "end" );

      for (a=2; a<12; a++)
         while (strlen(global_string[5][a]) < 38)
            strcat(global_string[5][a], " "); // pad string length

      key_sel = zmenu(5, key_sel, 50);
      switch (key_sel)
      {
         case  4: players[p].up_key    =  my_readkey(); break;
         case  5: players[p].down_key  =  my_readkey(); break;
         case  6: players[p].right_key =  my_readkey(); break;
         case  7: players[p].left_key  =  my_readkey(); break;
         case  8: players[p].jump_key  =  my_readkey(); break;
         case  9: players[p].fire_key  =  my_readkey(); break;
         case 10: players[p].map_key   =  my_readkey(); break;
         case 11: players[p].menu_key  =  my_readkey(); break;
      }
   } while (key_sel != 2);
   save_keys();
   clear(screen);
}

int joy_check(int p)
{
   if (p == 120) if (joy[0].stick[0].axis[1].d1) return 1;
   if (p == 121) if (joy[0].stick[0].axis[1].d2) return 1;
   if (p == 122) if (joy[0].stick[0].axis[0].d1) return 1;
   if (p == 123) if (joy[0].stick[0].axis[0].d2) return 1;
   if (p == 124) if (joy[0].button[0].b) return 1;
   if (p == 125) if (joy[0].button[1].b) return 1;
   if (p == 126) if (joy[0].button[2].b) return 1;
   if (p == 127) if (joy[0].button[3].b) return 1;
   if (p == 128) if (joy[0].button[4].b) return 1;
   if (p == 129) if (joy[0].button[5].b) return 1;
   if (p == 130) if (joy[0].button[6].b) return 1;
   if (p == 131) if (joy[0].button[7].b) return 1;

   if (p == 132) if (joy[1].stick[0].axis[1].d1) return 1;
   if (p == 133) if (joy[1].stick[0].axis[1].d2) return 1;
   if (p == 134) if (joy[1].stick[0].axis[0].d1) return 1;
   if (p == 135) if (joy[1].stick[0].axis[0].d2) return 1;
   if (p == 136) if (joy[1].button[0].b) return 1;
   if (p == 137) if (joy[1].button[1].b) return 1;
   if (p == 138) if (joy[1].button[2].b) return 1;
   if (p == 139) if (joy[1].button[3].b) return 1;
   if (p == 140) if (joy[1].button[4].b) return 1;
   if (p == 141) if (joy[1].button[5].b) return 1;
   if (p == 142) if (joy[1].button[6].b) return 1;
   if (p == 143) if (joy[1].button[7].b) return 1;
   return 0;
}

void function_key_check(void)
{

#ifdef NETPLAY
   if (key[KEY_F7]) // server 
   {
      control_lead_frames = 4;
      players[0].control_method = 3; // server
      players[0].active = 1;
      players[0].local_draw = 1;
      players[0].paused = 0;

      // full screen
      int b = 16; // frame width
      players[0].SX = b; // position on screen
      players[0].SY = b; 
      players[0].SW = SCREEN_W-b*2;
      players[0].SH = SCREEN_H-b*2;

      // set up one client
      players[1].active = 1;
      players[1].local_draw = 0;

      return;
   }
   if (key[KEY_F8]) // client 
   {
      control_lead_frames = 4;
      players[1].control_method = 4; // client
      players[1].active = 1;
      players[1].local_draw = 1;
      players[1].paused = 0;

      // full screen
      int b = 16; // frame width
      players[1].SX = b; // position on screen
      players[1].SY = b; 
      players[1].SW = SCREEN_W-b*2;
      players[1].SH = SCREEN_H-b*2;

      // server 
      players[0].active = 1;
      players[0].local_draw = 0;

      return;
   }

#endif


   if (key[KEY_F7])
   {
      while (key[KEY_F7]); // wait for release
      if (passcount_timer_fps < 200)
      { 
         set_passcount_timer_fps(passcount_timer_fps + 1);
      }   
   }
   if (key[KEY_F8])
   {
      while (key[KEY_F8]); // wait for release
      if (passcount_timer_fps > 10)
      { 
         set_passcount_timer_fps(passcount_timer_fps - 1);
      }   
   }

   if  (key[KEY_F9])
   {
      players[0].paused = 1;
      players[0].paused_passcount = 80;
   }
   if  (key[KEY_F10]) players[0].paused = 0;
   if  (key[KEY_F11])
   {
      players[1].paused = 1;
      players[1].paused_passcount = 80;
   }

   if  (key[KEY_F12]) players[1].paused = 0;

   if  (key[KEY_F5]) // both to player 0
   {
      players[1].PX = players[0].PX;
      players[1].PY = players[0].PY;
      players[1].left_right = players[0].left_right;
   }
   if  (key[KEY_F6]) // both to player 1 (purple)
   {
      players[0].PX = players[1].PX;
      players[0].PY = players[1].PY;
      players[0].left_right = players[1].left_right;
   }
   if  (key[KEY_F1])  // x split
   {
       players[0].active = 1;
       players[1].active = 1;
       set_screens(1);
   }
   if  (key[KEY_F2]) // y split
   {
      players[0].active = 1;
      players[1].active = 1;
      set_screens(2);
   }
   if  (key[KEY_F3]) // no split player 1 active
   {
      players[0].active = 1;
      players[1].active = 0;
      set_screens(0);
   }
   if  (key[KEY_F4]) // no split player 2 active
   {
      players[0].active = 0;
      players[1].active = 1;
      set_screens(0);
   }

#ifdef PRTSCR
   if ((key[KEY_CONTROL]) && (key[KEY_PRTSCR]))
   {
      FILE *filepntr;
      char fname[80];

      BITMAP *ss_bmp;
      PALETTE ss_pal;
    
      get_palette(ss_pal);
      ss_bmp = create_sub_bitmap(screen, 0, 0, SCREEN_W, SCREEN_H);

      text_mode(0);
      gui_fg_color = 10;
      sprintf(fname,"scrndump.bmp");
       
      if (file_select("Save Screen Dump as...", fname, "BMP"))
      {
          save_bitmap("dump.bmp", ss_bmp, ss_pal);
          destroy_bitmap(ss_bmp);
      }
      text_mode(0);
      gui_fg_color = 9;
   }
#endif
}

void player_key_check(int p)
{
   //  check for up
   if (players[p].up_key > 119) players[p].up = joy_check(players[p].up_key);
   else if (key[players[p].up_key]) players[p].up = 1;

   //  check for down
   if (players[p].down_key > 119) players[p].down = joy_check(players[p].down_key);
   else if (key[players[p].down_key]) players[p].down = 1;

   //  check for left
   if (players[p].left_key > 119) players[p].left = joy_check(players[p].left_key);
   else if (key[players[p].left_key]) players[p].left = 1;

   //  check for right
   if (players[p].right_key > 119) players[p].right = joy_check(players[p].right_key);
   else if (key[players[p].right_key]) players[p].right = 1;

   //  check for fire
   if (players[p].fire_key > 119) players[p].fire = joy_check(players[p].fire_key);
   else if (key[players[p].fire_key]) players[p].fire = 1;
   if (players[p].fire == 0) players[p].fire_held = 0;

   //  check for jump
   if (players[p].jump_key > 119) players[p].jump = joy_check(players[p].jump_key);
   else if (key[players[p].jump_key]) players[p].jump = 1;

   if ((players[p].map_key > 119) && (joy_check(players[p].map_key)) && (!players[p].map_held))
   {
      next_map_mode();
      players[p].map_held = 1;
   }
   if ((players[p].map_key > 119) && (!joy_check(players[p].map_key)) && (players[p].map_held)) players[p].map_held = 0;

   if ((players[p].map_key < 119) && (key[players[p].map_key]) && (!players[p].map_held))
   {
      next_map_mode();
      players[p].map_held = 1;
   }
   if ((players[p].map_key < 119) && (!key[players[p].map_key]) && (players[p].map_held)) players[p].map_held = 0;
   

   int kmenu = 0;
   //  check for menu
   if (players[p].menu_key > 119) kmenu = joy_check(players[p].menu_key);
   else if (key[players[p].menu_key]) kmenu = 1;
   
   if ((key[KEY_ESC]) || (kmenu))
   {
      game_exit=1;
      resume_allowed=1;
   }
}

void proc_controllers()
{
  poll_joystick(); // to avoid it being called more than once
// causes quite a delay!
#ifdef DEBUG_FUNCTION_KEYS
   function_key_check();
#endif   
   int p;
   for (p=0; p<NUM_PLAYERS; p++)
   {
      if (players[p].active)
      {
         // default for all control_methods
         // read local keys and set comp_move
         clear_keys(p);
         player_key_check(p);
         set_comp_move_from_controls(p);

         if (players[p].control_method == 3) server_control(p);
         if (players[p].control_method == 4) client_control(p);
         if (players[p].control_method == 0) // local control
         {
            // if change set in autoplay at passcount + 
            if (players[p].comp_move != players[p].old_comp_move)
            {
               extern int control_lead_frames; 
               players[p].old_comp_move = players[p].comp_move;
               players[p].autoplay[players[p].api_write][0] = passcount + control_lead_frames;
               players[p].autoplay[players[p].api_write][1] = players[p].comp_move;
               players[p].api_write++;
            }
         }

         // this is now common for all modes
         // set the current control config from autoplay
         int next_api_passcount = players[p].autoplay[players[p].api_read][0];
         if ((next_api_passcount > 0) && (passcount >= next_api_passcount))
         {
            set_controls_from_comp_move(players[p].autoplay[players[p].api_read][1],p ); // new controls
            players[p].api_read++;
         }
         else
         {
            set_controls_from_comp_move(players[p].autoplay[players[p].api_read-1][1],p ); // use previous
         }
      }
   }
}

void erase_autoplay(int p)
{
   int c, d;
   for (c = 0; c < 5000; c++)
      for (d = 0; d < 2; d++)
      {
         players[p].autoplay[c][d] = 0;
      }
   players[p].api_read = 0;
   players[p].api_write = 0;
   players[p].comp_move = 0;
   players[p].old_comp_move = 0;
}
void set_comp_move_from_controls(int p)
{
   players[p].comp_move = 0;
   if (players[p].left)  players[p].comp_move += 1;
   if (players[p].right) players[p].comp_move += 2;
   if (players[p].up)    players[p].comp_move += 4;
   if (players[p].down)  players[p].comp_move += 8;
   if (players[p].jump)  players[p].comp_move += 16;
   if (players[p].fire)  players[p].comp_move += 32;
}

void set_controls_from_comp_move(int t, int p)
{
   clear_keys(p);
   if (t > 31)
   {
      t -= 32;
      players[p].fire = 1;
   }
   if (t > 15)
   {
      t -= 16;
      players[p].jump = 1;
   }
   if (t > 7)
   {
      t -= 8;
      players[p].down=1;
   }
   if (t > 3)
   {
      t -= 4;
      players[p].up = 1;
   }
   if (t > 1)
   {
      t -= 2;
      players[p].right = 1;
   }
   if (t > 0)
   {
      t -= 0;
      players[p].left = 1;
   }
}

// network stuff

void server_control(int p) // this function runs the game under remote control from a client
{
#ifdef NETPLAY

   char msg[80];
   static int server_first_time = 1;
   static int connection = 0;
   static int who;

   // Initialize the server.
   if (server_first_time)
   {  
      server_first_time = 0;
      if (ServerInit())
      {
         allegro_message("Could find no internet driver for server.\n");
         exit(-1);
      }   
   }

   sprintf(msg,"Server Controlled Game! ");
   textout(screen, font, msg, 200,80,10);

   if (!connection)
   {
      int sl = ServerListen();
      sprintf(msg,"Server listen %-3d",sl);
      textout(screen, font, msg, 200,90,10);
      if (!sl) connection = 1;
   }
   if (connection)
   {

      // get messages from client
      packetsize = ServerReceive(packetbuffer, &who);
      if (packetsize)
      {
         sprintf(msg,"packetsize:%-3d  who:%d",packetsize,who);
         textout(screen, font, msg, 200,100,10);

         if(PacketRead("SPOL"))
         {
            int this_passcount = 0;
            unsigned char this_passcount_ho = PacketGetByte();
            unsigned char this_passcount_lo = PacketGetByte();
            this_passcount = this_passcount_ho*256 + this_passcount_lo;

/*            printf("----- Server Reply to Poll -----\n");
            printf("sync poll sent passcount:%d  \n", this_passcount);
            printf("sync poll sent high byte:%d  \n", this_passcount_ho);
            printf("sync poll sent low  byte:%d  \n", this_passcount_lo);
            printf("           -----               \n");
*/

            Packet("SREP");

            // first add the sent passcount
            PacketAddByte(this_passcount_ho);
            PacketAddByte(this_passcount_lo);

            // then add the server passcount
            unsigned char hi_byte = (unsigned char) (passcount/256);
            PacketAddByte(hi_byte);
            unsigned char lo_byte = (unsigned char) (passcount - (hi_byte*256));
            PacketAddByte(lo_byte);

/*            printf("server reply passcount:%d  \n", passcount);
            printf("server reply passcount high byte:%d  \n", hi_byte);
            printf("server reply passcount low  byte:%d  \n", lo_byte);

            printf("--------------------------------\n");
*/


            // reply to the same who that we received a message from
            ServerSendTo(packetbuffer, packetsize, who);
         }


         if(PacketRead("cmov"))
         {
            // this packet sent from clients is inserted into the server's player's autoplay array
            int this_comp_move = PacketGetByte();

            int p = PacketGetByte();
            int this_passcount = 0;
            unsigned char this_passcount_ho = PacketGetByte();
            unsigned char this_passcount_lo = PacketGetByte();
            this_passcount = this_passcount_ho*256 + this_passcount_lo;

            players[p].autoplay[players[p].api_write][0] = this_passcount;
            players[p].autoplay[players[p].api_write][1] = this_comp_move;
            players[p].api_write++;

            // and then rebroadcast to all clients

            Packet("smov");
            PacketAddByte(this_comp_move);
            PacketAddByte(p);

            int fpc = passcount;
            PacketAddByte(fpc/256);
            PacketAddByte(fpc - ((fpc/256)*256));

            ServerBroadcast(packetbuffer, packetsize);
         }
      } // end of receive


      if (players[p].comp_move != players[p].old_comp_move)  // players keys have changed
      {
         players[p].old_comp_move = players[p].comp_move;    // set new_old_comp_move

         int fpc = passcount + control_lead_frames;            // add CONTROL_LEAD_FRAMES to passcount

         // put in local array
         players[p].autoplay[players[p].api_write][0] = fpc;
         players[p].autoplay[players[p].api_write][1] = players[p].comp_move;
         players[p].api_write++;

         // broadcast to all clients
         Packet("smov");
         PacketAddByte(players[p].comp_move);
         PacketAddByte(p);

         unsigned char hi_byte = (unsigned char) (fpc/256);
         PacketAddByte(hi_byte);
         unsigned char lo_byte = (unsigned char) (fpc - (hi_byte*256));
         PacketAddByte(lo_byte);

         ServerBroadcast(packetbuffer, packetsize);
      }
   }
#endif
}

void client_control(int p)

// this function sends player data to a remote server
// it does not get entered into the local autoplay until returned from the server


{
#ifdef NETPLAY
   char msg[80];
   static int connected = 0;
   static int client_first_time = 0;

   static int server_sync = 0;

   if (client_first_time == 0)
   {
      client_first_time =1;
      if (ClientInit(serveraddress))
      {
         allegro_message("Could find no internet driver for client.\n");
         rest(1500);
         exit(-1);
      }
      else
      {
         sprintf(msg,"Found internet driver for client!");
         textout(screen, font, msg, 100,60,10);
         rest(500);
      }
   }
   if (!connected)
   {
      sprintf(msg,"unconnected");
      textout(screen, font, msg, 200,80,10);

      // Check for answer from server.
      if (ClientCheckResponse() == 0)
      {
         connected = 1;
         sprintf(msg,"connected  ");
         textout(screen, font, msg, 200,80,10);
      }
      if (ClientCheckResponse() == -1)
      {
         allegro_message("no response!\n");
      }
   }
   if (connected)
   {
      sprintf(msg,"Client Controlled Game! ");
      textout(screen, font, msg, 300,80,9);

      sprintf(msg,"Server sync %d", server_sync);
      textout(screen, font, msg, 300,88,9);


      // send snyc poll every x passcounts
      if (passcount % 20 == 0)
      {
         Packet("SPOL");

         unsigned char hi_byte = (unsigned char) (passcount/256);
         PacketAddByte(hi_byte);
         unsigned char lo_byte = (unsigned char) (passcount - (hi_byte*256));
         PacketAddByte(lo_byte);

/*         printf("------Client Initiated Poll----\n");
         printf("sync poll sent passcount:%d  \n", passcount);
         printf("sync poll sent high byte:%d  \n", hi_byte);
         printf("sync poll sent low  byte:%d  \n", lo_byte);
         printf("-------------------------------\n");
*/


         ClientSend(packetbuffer, packetsize);
      }

      packetsize = ClientReceive(packetbuffer);
      if (packetsize)
      {
         sprintf(msg,"packetsize:%-3d ",packetsize);
         textout(screen, font, msg, 200,100,10);

         if(PacketRead("SREP"))
         {
            // sent passcount
            unsigned char sp_ho = (unsigned char)PacketGetByte();
            unsigned char sp_lo = (unsigned char)PacketGetByte();
            int sp_passcount = (sp_ho * 256) + sp_lo;

            // server passcount
            unsigned char sv_ho = (unsigned char)PacketGetByte();
            unsigned char sv_lo = (unsigned char)PacketGetByte();
            int sv_passcount = (sv_ho * 256) + sv_lo;

            server_sync = sv_passcount-passcount; // ahead or behind
            install_int_ex(inc_timer_passcount, BPS_TO_TIMER(passcount_timer_fps + server_sync)); // adjust timer

            printf("---Sync Reply Received--\n");
            printf("sync poll sent --------- %d \n",sp_passcount);
            printf("server passcount ------- %d \n",sv_passcount);
            printf("sync reply got --------- %d \n",passcount);
            printf("----------------------\n");

         }

         if(PacketRead("smov"))
         {
            // this packet sent from the server is inserted into the local player's autoplay array

            int this_comp_move = PacketGetByte();
            int p = PacketGetByte();

            unsigned char sp_ho = (unsigned char)PacketGetByte();
            unsigned char sp_lo = (unsigned char)PacketGetByte();
            int sp_passcount = (sp_ho * 256) + sp_lo;

            players[p].autoplay[players[p].api_write][0] = sp_passcount;
            players[p].autoplay[players[p].api_write][1] = this_comp_move;
            players[p].api_write++;

         }
      }
      if (players[p].comp_move != players[p].old_comp_move)  // players keys have changed
      {
         players[p].old_comp_move = players[p].comp_move;
         Packet("cmov");
         PacketAddByte(players[p].comp_move);
         PacketAddByte(p);

         int fpc = passcount + control_lead_frames;  // add CONTROL_LEAD_FRAMES to passcount
         unsigned char hi_byte = (unsigned char) (fpc/256);
         PacketAddByte(hi_byte);
         unsigned char lo_byte = (unsigned char) (fpc - (hi_byte*256));
         PacketAddByte(lo_byte);

         ClientSend(packetbuffer, packetsize);
      }
   }
#endif
}

void set_start_level(int s)
{
   extern char global_string[20][25][80]; // menu.c
   extern int start_level;
   start_level = s;
   sprintf(global_string[7][2], "Start Level  (%d)",start_level);
}

void set_passcount_timer_fps(int x)
{
   passcount_timer_fps = x;
   install_int_ex(inc_timer_passcount, BPS_TO_TIMER(passcount_timer_fps));
}

void set_speed(void)
{
   extern int speed;
   switch (speed)
   {
      case 1:
           sprintf(global_string[8][3],"   Speed:Slow (20 fps)   ");
           set_passcount_timer_fps(20);
      break;
      case 2:
           sprintf(global_string[8][3],"  Speed:Normal (30 fps)  ");
           set_passcount_timer_fps(30);
      break;
      case 3:
           sprintf(global_string[8][3],"   Speed:Fast (40 fps)   ");
           set_passcount_timer_fps(40);
      break;
      case 4:
           sprintf(global_string[8][3],"  Speed:Faster (50 fps)  "); 
           set_passcount_timer_fps(50);
      break;
      case 5:
           sprintf(global_string[8][3]," Speed:Fastest (60 fps)  "); 
           set_passcount_timer_fps(60);
      break;
   }
   set_config_int("GAMECONTROLS", "speed", speed);
}

void set_map_var(void)
{
   extern int tmx, tmy;   // menu pos
   extern int tmtx, tmty; // text position
   extern int mx;
   extern int my;
   extern int md;         // menu map double
   extern int map_double; // game map double
   extern float steps;
   extern int map100_x, map100_y;

   md = 1; // defaults
   steps = 20;
   my = 40+(10*8);
   tmy = 26;
   tmx = SCREEN_W/2;
   my = tmy + 100;
   tmty = my-16; // text

   if (SCREEN_W == 1600)
   {
      map_double = 4;
      md = 10;
      steps = 12;
   }
   if (SCREEN_W == 1280)
   {
      map_double = 3;
      md = 8;
      steps = 16;
   }
   if (SCREEN_W == 1024)
   {
      map_double = 3;
      md = 4;
      steps = 20;
   }
   if (SCREEN_W == 800)
   {
      map_double = 2;
      md = 3;
      steps = 24;
   }
   if ((SCREEN_W == 640) && (SCREEN_H == 480))
   {
      map_double = 2;
      md = 2;
      steps = 28;
   }
   if ((SCREEN_W == 640) && (SCREEN_H == 400))
   {
      map_double = 1;
      md = 2;
      steps = 40;
   }

   mx = SCREEN_W/2-(md*50);
   tmtx = mx+(md*50); //text pos

   // 320 sets its own or uses these ones !!

   if (SCREEN_W == 320)
   {
      map_double = 1;
      if (map100_y < 20)
         map100_y = 20;
      md = 1;
      if (SCREEN_H == 240)
      {
         my = 124; // flush with bottom of screen
         tmty = my-16;
         steps = 100;
      }
      if (SCREEN_H == 200)
      {
         mx = 28 + 16; // 28 + flush with right of screen
         my = 84;      // flush with bottom of screen
         tmx = SCREEN_W/2 + 39;  // move menu over

         tmtx = mx+(md*50);
         tmty = my-16;
         steps = 120;
      }
   }
   if (SCREEN_W < 320)
   {
      map_double = 1;
      md = 1;
   }

   // if map is off screen move it
   if (map100_x > SCREEN_W - map_double*100)
      map100_x = SCREEN_W - map_double*100;
   if (map100_y > SCREEN_H - map_double*100)
      map100_y = SCREEN_H - map_double*100;

}


