#include <math.h>
#include <allegro.h>
#include "lift.h"
#include "pm.h"

// global variables
extern int item[500][16];
extern float itemf[500][4];
extern struct lift *lifts[20];
extern BITMAP *memory_bitmap[NUM_SPRITES];
extern BITMAP *level_2000, *scrn_buffer;
extern BITMAP *map100_bmp, *map100_bkg;
extern BITMAP *dtemp;
extern int zz[20][NUM_ANS];
extern int l[100][100];    /* level */
extern int passcount;
extern int game_map_on, map_empty_color;
extern int level_done;
extern int num_enemy;
extern float LIFE;
extern int LIVES;
extern int bomb[20][5];
extern int lines[50][6];
extern float y_adj;
extern int lit_item;


#ifdef DUMB
extern DUH *myduh;
extern AL_DUH_PLAYER *dp;
#endif



void draw_items()
{
   // update items on scrn_buffer
   int a, c, p, x, y;
   for (c=0; c<500; c++)
   {
      if (item[c][0])
      {
         int shape = 255;  // default
         x = (int) itemf[c][0];
         y = (int) itemf[c][1];
         for (p=0; p<NUM_PLAYERS; p++)
         {
            if ((players[p].active) && (!players[p].paused) && (players[p].local_draw) )
            {
               if (game_map_on) putpixel(map100_bmp, x/20, y/20, 7);
               set_clip(scrn_buffer, players[p].SX, players[p].SY, players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);
               if ((item[c][0] != 99) && ((players[p].player_carry-1) != c) )
               {
                  if ((x > players[p].WX-20) && (x < (players[p].WX + players[p].SW)) && (y > players[p].WY-20) && (y < (players[p].WY + players[p].SH)))
                  {
                     a = item[c][1];                      // get shape
                     if (a < NUM_SPRITES) shape = a;      // bitmap
                     if (a > 999) shape = zz[0][a-1000];  // ans

                     if (item[c][0] == 11)     // rocket is the only one that rotates
                        rotate_sprite(scrn_buffer, memory_bitmap[shape], players[p].SX+x-players[p].WX, players[p].SY+y-players[p].WY, itofix(item[c][10]/10));
                     else if (item[c][2] == 1) // normal draw
                        draw_sprite(scrn_buffer, memory_bitmap[shape], players[p].SX+x-players[p].WX, players[p].SY+y-players[p].WY);
                  }
               }   
            }
         }   
         set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
      }
   }   
}

void proc_item_move()
{
   int a, c, x, y;
   for (c=0; c<500; c++)
      if ((item[c][0]) && (item[c][3])) // active and not stationary
         if (item[c][0] != 98) // not lit rocket
            if ((c != (players[0].player_carry-1) ) && (c != (players[1].player_carry-1) )) // not being carried
            {
               itemf[c][0] += itemf[c][2];  // xinc
               itemf[c][1] += itemf[c][3];  // yinc
               x = (int) itemf[c][0];
               y = (int) itemf[c][1];
               if (itemf[c][2] > 0) itemf[c][2] -= .01; // slow down x move
               if (itemf[c][2] < 0) itemf[c][2] += .01; // slow down x move
   
               if (itemf[c][2] > 0)        // right
                  if (is_right_solid(x,y)) // check for block right
                     itemf[c][2] = 0;      // stop
   
               if (itemf[c][2] < 0)        // left
                  if (is_left_solid(x,y))  // check for block left
                     itemf[c][2] = 0;      // stop
   
               if (itemf[c][3] < 0) // rising
               {
                  if (!is_up_solid(x,y,0,0)) itemf[c][3] += .1; // de-accel
                  else itemf[c][3] = 0; // stop y move if hit ceiling
               }
               if (itemf[c][3] > 0) // falling
               {
                  if (!is_down_solid(x,y, 1)) // check for block below
                  {
                     itemf[c][3] += .1;  // accel
                     if (itemf[c][3] > 3) itemf[c][3] = 3;  // max accel
                  }
                  else
                  {
                     if (itemf[c][2] > 0) itemf[c][2] -= .15; // slow down x move if on ground
                     if (itemf[c][2] < 0) itemf[c][2] += .15; // slow down x move if on ground
                     itemf[c][1] = ((y/20)*20); // align with ground
                     itemf[c][3] = 0; // stop y move if on ground
                  }
               }
               if (itemf[c][3] == 0) // yinc steady
               {
                  a = is_down_solid(x,y,1); // check for block below
                  if (a==0)
                  {
                     itemf[c][3] += .1;  // accel
                     if (itemf[c][3] > 4) itemf[c][3] = 4;  // max accel
                  }
                  if (a==1)
                  {
                     itemf[c][3] = 0; // stop y move if on ground
                     if (itemf[c][2] > 0) itemf[c][2] -= .03; // slow down x move if on ground
                     if (itemf[c][2] < 0) itemf[c][2] += .03; // slow down x
                  }
                  if ((a > 31) && (a < 1024)) // item riding lift
                  {
                     itemf[c][0] += lifts[a-32]->fxinc; // move with xinc
                     itemf[c][1]  = lifts[a-32]->fy - 20 + lifts[a-32]->fyinc; // align with Y1
                     if (itemf[c][2] > 0) itemf[c][2] -= .03; // slow down x move if on ground
                     if (itemf[c][2] < 0) itemf[c][2] += .03; // slow down x
                  }
                  if (a > 1023) /* item on line  */
                  {
                     itemf[c][1]  = y_adj ; // align with line
                     itemf[c][2] = 0; // xinc
                     itemf[c][3] = 0; // yinc
                  }
               }
            }
}
void proc_item_collison()
{
   int c, d, p, x, y;
   for (x=0; x<500; x++)
      if (item[x][0])
         for (p=0; p<NUM_PLAYERS; p++)
            if ((players[p].active) && (!players[p].paused) )
               if ((players[p].PX  > itemf[x][0] - 16) && (players[p].PX  < itemf[x][0] + 16))
                  if ((players[p].PY  > itemf[x][1] - 16) && (players[p].PY  < itemf[x][1] + 16))
                  {
                     // try to pick up item if carryable
                     if (item[x][3] == -1)
                        if ((players[p].fire) && (!players[p].player_carry))  // if not already carrying and fire button pressed
                           players[p].player_carry = x+1;

                     switch (item[x][0]) // item type
                     {
                        case 1:  // door
                        {
                           event(5);
                           players[p].PX  = item[x][6] * 20;
                           players[p].PY  = item[x][7] * 20;
                           players[p].left_speed=0;
                           players[p].right_speed=0;
                           players[p].jump_count=0;
                           players[p].fall_count=0;
                        }
                        break;
                        case 2: // bonus
                        {
                           int ev;
                           if (item[x][7]) // LIFE increment
                           {
                              if (players[p].LIFE < 100)
                              {
                                 item[x][0] = 0;
                                 players[p].LIFE += item[x][7];
                                 if (players[p].LIFE > 100) players[p].LIFE = 100;
                                 ev = 6;
                              }
                              else ev = 26;
                           }
                           if (item [x][8]) // bullet increment
                           {
                              extern int max_bullets;
                              if (players[p].num_bullets < max_bullets) // only if not full
                              {
                                 item[x][0] = 0;
                                 players[p].num_bullets += item[x][8];
                                 if (players[p].num_bullets > max_bullets) players[p].num_bullets = max_bullets;
                                 ev = 7;
                              }
                              else ev = 27;
                           }
                           if (item[x][9]) // time increment
                           {
                              extern int level_time;
                              item[x][0] = 0;
                              level_time += item[x][9] * 50;
                              ev=8;
                           }

                           if ((item[x][7]) && (item[x][8])) // fruit (has both LIFE and bullets)
                              event(29);
                           else event(ev);
                        }
                        break;
                        case 3: // exit
                        {
                           if ( (item[x][8]) && (num_enemy) )
                           {
                              event(3);
                           }
                           else
                           {
                              level_done = 1;
                              event(4);
                           }
                        }
                        break;
                        case 4: // key
                        {
      #ifdef KEY_ANIMATION
      
                          extern int timer_passcount;
                          int temp_timer_passcount = timer_passcount;
                                               int WX, WY;
                           float x1 = itemf[x][0];
                           float y1 = itemf[x][1];
                           float x2 = (item[x][6] + item[x][8]) * 10;
                           float y2 = (item[x][7] + item[x][9]) * 10;
                           float xsize = x2-x1;
                           float ysize = y2-y1;
                           float vx=x1;
                           float vy=y1;
                           float xinc;
                           float yinc;
                           float bsize;
                           int steps;
                           int div;
                           int shape, a, b;
                           if (fabs(xsize)>fabs(ysize)) bsize = fabs(xsize);
                           else bsize = fabs(ysize);

                           // get the proper player shape
                           int pans = 9 - (p*3);
                           if (players[p].up)   pans+=1;
                           if (players[p].down) pans+=2;
                           int ans_pos = (players[p].PXint/4) % zz[4][pans];
                           int p_shape = zz[ans_pos+5][pans];

                           div = (int)(12+bsize/2000*112);
                           steps = (int)(bsize/div);
      
                           xinc = xsize/steps;
                           yinc = ysize/steps;

                           // move to the key's destination
                           for (b=0; b<steps; b++)
                           {
                              vx += xinc;
                              vy += yinc;
#ifdef DUMB
                              al_poll_duh(dp);
#endif

                              WX = (int)(vx-SCREEN_W/2);
                              WY = (int)(vy-SCREEN_H/2);
      
                              if (WX < 0) WX = 0;
                              if (WX > 2000-SCREEN_W) WX = 2000-SCREEN_W;
                              if (WY > 2000-SCREEN_H) WY = 2000-SCREEN_H;
                              if (WY < 0) WY = 0;
      
                              blit(level_2000, scrn_buffer, WX, WY, 0, 0, SCREEN_W, SCREEN_H);

                              // draw player
                              if (players[p].left_right) draw_sprite(scrn_buffer, memory_bitmap[p_shape],players[p].PXint-WX, players[p].PYint-WY);
                              else draw_sprite_h_flip(scrn_buffer, memory_bitmap[p_shape], players[p].PXint-WX, players[p].PYint-WY);

                              // draw key
                              shape = zz[5][item[x][1]-1000];
                              draw_sprite(scrn_buffer, memory_bitmap[shape], (int)vx-WX, (int)vy-WY);

                              // enemy_draw_and_collision();
                              // draw_items();

                              blit(scrn_buffer, screen, 0, 0, 0, 0,SCREEN_W, SCREEN_H );
                              rest(2);
                           }

                           // rotate the key
                           for (b=0; b<60; b++)
                           {
#ifdef DUMB
                              al_poll_duh(dp);
#endif
                              rest(8);
                              a = item[x][1];
                              if (a < NUM_SPRITES) shape = a; /* bitmap */
                              if (a > 999) shape = zz[5][a-1000]; /* ans */
                              blit(memory_bitmap[0], screen, 0, 0, (int)vx-WX, (int)vy-WY, 20, 20);
                              rotate_scaled_sprite(screen, memory_bitmap[shape], (int)vx-WX, (int)vy-WY, itofix(0), ftofix(1));
                           }
#endif
                           // remove the key
                           item[x][0] = 0;

                           // remove the blocks
                           event(2);
                           for (c = item[x][6]; c <= item[x][8]; c++)
                              for (y = item[x][7]; y <= item[x][9]; y++)
                              {
                                 l[c][y] = 0; // remove from block array
                                 blit(memory_bitmap[0], level_2000, 0, 0, c*20, y*20, 20, 20); // remove from background
                                 putpixel(map100_bkg, c, y, map_empty_color); // remove from map
                              }
                           draw_lift_lines(); // in case removing the key blocks erases lift lines
#ifdef KEY_ANIMATION
                           // move back to the player's location
                           int db = 1; // to double return speed set db to 2
                           for (b=0; b<steps; b+=db)
                           {
#ifdef DUMB
                              al_poll_duh(dp);
#endif
                              vx -= (db*xinc);
                              vy -= (db*yinc);
                              WX = (int)(vx-SCREEN_W/2);
                              WY = (int)(vy-SCREEN_H/2);
                              if (WX < 0) WX = 0;
                              if (WX > 2000-SCREEN_W) WX = 2000-SCREEN_W;
                              if (WY > 2000-SCREEN_H) WY = 2000-SCREEN_H;
                              if (WY < 0) WY = 0;
      
                              blit(level_2000, scrn_buffer, WX, WY, 0, 0, SCREEN_W, SCREEN_H);

                              // draw player
                              if (players[p].left_right) draw_sprite(scrn_buffer, memory_bitmap[p_shape],players[p].PXint-WX, players[p].PYint-WY);
                              else draw_sprite_h_flip(scrn_buffer, memory_bitmap[p_shape], players[p].PXint-WX, players[p].PYint-WY);

                              // draw key
                              shape = zz[5][item[x][1]-1000];
                              draw_sprite(scrn_buffer, memory_bitmap[shape], (int)vx-WX, (int)vy-WY);

                              // enemy_draw_and_collision();
                              // draw_items();

                              blit(scrn_buffer, screen, 0, 0, 0, 0,SCREEN_W, SCREEN_H );
                              rest(2);
                           }
                           blit(level_2000, scrn_buffer, WX, WY, 0, 0, SCREEN_W, SCREEN_H);

                          rest(300);
                          timer_passcount = temp_timer_passcount;
   
#endif
                        }
                        break;
                        case 6: // free man
                        {
                           item[x][0] = 0;
                           players[p].LIVES++;
                           event(9);
                        }
                        break;
                        case 7:
                        {
                           event(10);
                           players[p].LIFE -= (float) item[x][8]/10;
                        }
                        break;
                        case 8: // un-lit bomb
                        {
//                           event(24);
                           item[x][0] = 99;     // change to lit bomb
                           item[x][3] = -1;     // make carryable (if not already)
                           for (d=0; d<20; d++)
                           {
                              if (!bomb[d][0])  // find empty
                              {
                                 bomb[d][0] = 32 + x;                 // link to item
                                 bomb[d][1] = item[x][9] * zz[4][25]; // total fuse wait
                                 bomb[d][2] = item[x][9];             // seq fuse wait
                                 bomb[d][3] = item[x][7];             // damage
                                 bomb[d][4] = 1;                      // for blow up
                                 d = 20;                              // end bomb loop
                              }
                              else if (d == 19) item[x][0] = 0; // erase if no space in the bomb array
                           }
                           
                        }
                        break;
                        case 10: // pop-up message
                        {
                           extern int pop_msg;
                           extern int pop_msg_count;
                           pop_msg = x+1;
                           pop_msg_count = 120;
                        }
                        break;
                        case 11: // rocket
                        {
                           event(25);
                           item[x][0] = 98;   // new type - lit rocket
                           item[x][1] = 1026; // new ans
                           item[x][2] = 0;    // no draw
                           item[x][3] = -1;   // carryable
                           itemf[x][3] = 0;   // stop if falling

                        }
                        break;
                        case 12: // warp
                        {
                           extern int start_mode, play_level;
                           play_level = item[x][8];
                           start_mode = 1;
                        }
                        break;
      
                        case 14: // switch
                        {
                           if (item[x][7]<passcount) // if not busy because of recent switch lockout
                           {
                              // if falling and landing on it
                              if ((players[p].PX  > itemf[x][0] - 12) && (players[p].PX  < itemf[x][0] + 12))
                                 if ((players[p].PY  > itemf[x][1] - 16) && (players[p].PY  < itemf[x][1] - 8))
                                    if (players[p].fall_count)
                                    {
                                       event(30);
                                       item[x][7] = passcount + 4; // switch lockout for next 4 frames
                                       item[x][6] = !item[x][6];
                                       if (item[x][6])             // on
                                          item[x][1] = item[x][8]; // on bmp
                                       if (!item[x][6])            // off
                                          item[x][1] = item[x][9]; // off bmp

                                       // toggle blocks
                                       for (c=0; c<100; c++)
                                          for (y=0; y<100; y++)
                                          {
                                             if (l[c][y] == item[x][11]) // empty block
                                             {
                                                l[c][y] = item[x][10]; // replace with solid block
                                                blit(memory_bitmap[item[x][10]], level_2000, 0, 0, c*20, y*20, 20, 20);
                                                putpixel(map100_bkg, c, y, 10);
                                                draw_lift_lines();
                                             }
                                             else if (l[c][y] == item[x][10]) // solid block
                                             {
                                                l[c][y] = item[x][11]; // replace with empty
                                                blit(memory_bitmap[item[x][11]], level_2000, 0, 0, c*20, y*20, 20, 20);
                                                putpixel(map100_bkg, c, y, 0);
                                                draw_lift_lines();
                                             }
                                          }
                                    }
                           }
                        }
                        break;

                        case 15: // sproingy
                        {
                           if ((players[p].PX  > itemf[x][0] - 10) && (players[p].PX  < itemf[x][0] + 10))
                              if ((players[p].PY  > itemf[x][1] - 16) && (players[p].PY  < itemf[x][1] - 8))
                                 if (players[p].fall_count) // if falling
                                    if (players[p].jump)    // if jump pressed
                                    {
                                       event(31);
                                       players[p].ex_jump = 1;
                                       players[p].jump_count=1.27;
                                       players[p].jump_sinc=item[x][6];
                                       players[p].jump_sinc = players[p].jump_sinc/100;
                                       if (players[p].jump_sinc < .005) players[p].jump_sinc = .05;
                                       players[p].pmovey = item[x][7];
                                       if (players[p].pmovey < 5) players[p].pmovey = 5;
                                    }
                        }
                        break;
                     } // end of switch case
                  } // end of if on screen
}

void proc_lit_rocket(int draw)
{
   int c, d, shape;
   float angle;
   for (c=0; c<500; c++)
      if (item[c][0] == 98) // lit rocket!
      {
         int x, y, p;
         int max_speed = item[c][8]*1000;
         int accel = item[c][9];
         int rot_inc = item[c][6];
         lit_item = 1;

         if (item[c][11] < max_speed) item[c][11]+=accel;   // speed and accel

         // set angle and speed
         angle = ( (float) (item[c][10]-640) / 64/10)*1.57; // convert to radians
         itemf[c][2] = cos(angle) * item[c][11]/1000;       // hypotenuse is the speed!
         itemf[c][3] = sin(angle) * item[c][11]/1000;

         x = (int) (itemf[c][0] += itemf[c][2]); // do the increments
         y = (int) (itemf[c][1] += itemf[c][3]);

         if (game_map_on) putpixel(map100_bmp, x/20, y/20, 14);
         shape = zz[0][item[c][1]-1000]; // ans
         for (p=0; p<NUM_PLAYERS; p++)
            if (players[p].active)
            {
               set_clip(scrn_buffer, players[p].SX, players[p].SY,
               players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);
               if (draw) rotate_sprite(scrn_buffer, memory_bitmap[shape], players[p].SX+x-players[p].WX, players[p].SY+y-players[p].WY, itofix(item[c][10]/10));
               if (c == (players[p].player_carry-1)) // player is riding this rocket!
               {
                  players[p].fall_count=0;
                  players[p].PY  = itemf[c][1] + itemf[c][3];
                  if (players[p].PX  >= itemf[c][0]) players[p].PX  = itemf[c][0] + itemf[c][2] +14;
                  if (players[p].PX  < itemf[c][0])  players[p].PX  = itemf[c][0] + itemf[c][2] -14;
                  players[p].PXint = (int)players[p].PX ;
                  players[p].PYint = (int)players[p].PY ;
      
                  if (players[p].left)  item[c][10]-=rot_inc;
                  if (players[p].right) item[c][10]+=rot_inc;
      
               }
               if ( ((itemf[c][3]<0) && (is_up_solid(x,y,0,0)==1)) || ((itemf[c][3]>0) && (is_down_solid(x,y,0)==1)) )
               {
                  if (c == (players[p].player_carry-1)) /* player is riding this rocket! */
                     if (is_down_solid(players[p].PXint, players[p].PYint,0)==1)
                        players[p].PY  -= fmod (players[p].PY , 20); /* align with floor */

                  for (d=0; d<20; d++)  // make boom!
                     if (!bomb[d][0])   // find empty
                     {
                        itemf[c][3] = .1;        // slow down
                        bomb[d][0] = 32 + c;     // link to item
                        bomb[d][1] = 5;          // total fuse wait
                        bomb[d][2] = 1;          // seq fuse wait
                        bomb[d][3] = item[c][7]; // damage
                        bomb[d][4] = 1;          // for blow up
                        item[c][0] = 99;         // change to lit bomb
                        d = 20;                  // end bomb loop
                     }
      
                  if (d == 19) item[c][0] = 0;   // erase, if no space in the bomb array
               }
            }
         set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
      }
}
void proc_player_carry(int draw)
{
   int p, x, y;
   for (p=0; p<NUM_PLAYERS; p++)
   {
      if ((players[p].active) && (!players[p].paused) )
      {
         if (players[p].player_carry)  // player is carrying item
         {
            int pc = players[p].player_carry-1; // number of item
            if (item[pc][0] != 98) // not lit rocket
            {
               itemf[pc][1] = players[p].PY  - 2;
               if (!players[p].left_right) itemf[pc][0] = players[p].PX  - 15;
               if (players[p].left_right) itemf[pc][0] = players[p].PX  + 15;
               x = (int) itemf[pc][0];
               y = (int) itemf[pc][1];
               if (game_map_on) putpixel(map100_bmp, x/20, y/20, 7);
               if (item[pc][0] != 99) // not lit bomb
               {
                  int a, shape;
                  a = item[pc][1];                     // get shape
                  if (a < NUM_SPRITES) shape = a;      // bitmap
                  if (a > 999) shape = zz[0][a-1000];  // ans
                  if (item[pc][2] == 1)                // draw mode normal
                  if (draw) draw_sprite(scrn_buffer, memory_bitmap[shape], players[p].SX+x-players[p].WX, players[p].SY+y-players[p].WY);
               }
            }
            if (!players[p].fire) // drop
            {
               players[p].player_carry = 0;
               if (item[pc][0] != 98) // not lit rocket
               {
                  x = (int)itemf[pc][0];
                  y = (int)itemf[pc][1];
                  itemf[pc][2] = 0;  // xinc = 0
                  if (players[p].fall_count) itemf[pc][3] = (sin(1.57-players[p].fall_count) * players[p].pmovey);
                  if (players[p].jump_count) itemf[pc][3] = (sin(players[p].jump_count) * players[p].pmovey);
  
                  if (players[p].up) itemf[pc][3] = - 6 -(sin(players[p].jump_count) * players[p].pmovey)/4 ; // throw item upwards

                  if (players[p].p_xmove > 0)
                     if (!is_right_solid(x,y))
                        itemf[pc][2] = players[p].p_xmove;
  
                  if (players[p].p_xmove < 0)
                     if (!is_left_solid(x,y))
                        itemf[pc][2] = players[p].p_xmove;
               }
            }
         }
      }
   }      
}

void proc_lit_bomb(int draw)
{
   int a, c, d, e, f, p, x, y;
   for (d=0; d<20; d++)
      if (bomb[d][0])   // bomb lit!
      {
         lit_item = 1; // global variable to stop bomb fuse hiss
         bomb[d][1]--; // decrement fuse count
         if (bomb[d][1] > 0)
         {
            e = bomb[d][1] / bomb[d][2]; // set shape
            c = zz[16-e][25];
            x = (int)itemf[bomb[d][0]-32][0];
            y = (int)itemf[bomb[d][0]-32][1];
  
            if (bomb[d][1] < (bomb[d][2] * 5)) // start blow-up
            {
               // force player to drop item
               if (players[0].player_carry-1 == bomb[d][0]-32) players[0].player_carry = 0;
               if (players[1].player_carry-1 == bomb[d][0]-32) players[1].player_carry = 0;

               a = ((bomb[d][2] * 6) - bomb[d][1]); // 50 - ticks
               a = 2 * a * bomb[d][3]; // 2 times damage
               a = a / (bomb[d][2] * 5);  // / 50
   
               if (game_map_on && draw)
               {
                  rect(map100_bmp, (x/20)-(a/40), (y/20)-(a/40),(x/20)+(a/40), (y/20)+(a/40),10);
                  stretch_sprite(map100_bmp, memory_bitmap[c], (x/20) - (a/40), (y/20) - (a/40), 1 + (a/20), 1 + (a/20) );
               }
               for (p=0; p<NUM_PLAYERS; p++)
                  if ((players[p].active) && (!players[p].paused) && (players[p].local_draw) )
                  {
                     if (draw)
                     {
                        set_clip(scrn_buffer, players[p].SX, players[p].SY, players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);
                        stretch_sprite(scrn_buffer, memory_bitmap[c], (players[p].SX+x-players[p].WX) - (a/2), (players[p].SY+y-players[p].WY) - (a/2), 20 + a, 20 +a );
                     }   
                  }
               set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
            }
            else
            {
               for (p=0; p<NUM_PLAYERS; p++)
                  if ((players[p].active) && (!players[p].paused) && (players[p].local_draw) )
                  {
                     if (draw)
                     {
                        set_clip(scrn_buffer, players[p].SX, players[p].SY, players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);
                        draw_sprite(scrn_buffer, memory_bitmap[c], players[p].SX+x-players[p].WX, players[p].SY+y-players[p].WY);
                     }   
                  }
               set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
            }

         }
         if (bomb[d][1] < (bomb[d][2] * 6)) // fuse done !
         {
            if (bomb[d][4])  // first time only
            {
               // check for other co-located bombs
               for (c=0; c<20; c++)
                  if ((bomb[c][0]) && (c != d))
                     if (x == itemf[bomb[c][0]-32][0])
                        if (y == itemf[bomb[c][0]-32][1])
                           if (bomb[d][1] == bomb[c][1]-1)
                           {
                              item[ bomb[c][0]-32 ] [0] = 0;
                              bomb[c][0] = 0;
                           }

               event(22);
               bomb[d][1] = 23;  // speed up ans
               bomb[d][2] = 4;
               bomb[d][4] = 0;
            }
         }

         if (bomb[d][1] < (bomb[d][2] * 3)) // do the damage!
         {
            extern int Ei[100][32];
            extern float Ef[100][16];
            c = bomb[d][3];  /* damage window */
            x = (int)itemf[ bomb[d][0]-32 ][0];
            y = (int)itemf[ bomb[d][0]-32 ][1];
   
            for (e=0;e<100;e++) // enemies in damage window?
               if (Ei[e][0])
                  if (Ef[e][0] > ((x-c)) )
                     if (Ef[e][0] < ((x+c)) )
                        if (Ef[e][1] > ((y-c)) )
                           if (Ef[e][1] < ((y+c)) )
                           {
                              Ei[e][31] = 2; // set bomb hit
                              event(23);
                           }
   
            if (players[0].PX  > (x-c)) // is player in window?
               if (players[0].PX  < (x+c))
                  if (players[0].PY  > (y-c))
                     if (players[0].PY  < (y+c))
                     {
                        players[0].LIFE -= 3;
                     }
            c /= 20;  // convert to (0-100)
            x /= 20;
            y /= 20;
   
            for (e = (x-c); e < (x+c)+1; e++)    // erase on the maps
               for (f = (y-c); f < (y+c)+1; f++)
                 if ((e>0) && (e<99) && (f>0) && (f<99)) // if on screen
                     if ((l[e][f] > 63) && (l[e][f] < 96)) // if bombable
                     {
                        l[e][f] = 0;
                        putpixel(map100_bkg, e, f, map_empty_color);
                        blit(memory_bitmap[0], level_2000, 0, 0, e*20, f*20, 20, 20);
                     }
            draw_lift_lines();
         }

         if (bomb[d][1] < 1)  // bomb done
         {
            item[ bomb[d][0]-32 ] [0] = 0;
            bomb[d][0] = 0;  // set to inactive
         }
      }
}
