#include <math.h>
#include <allegro.h>
#include "lift.h"
#include "pm.h"

extern struct lift *lifts[20];
extern struct lift_step *lift_steps[20][20];

extern BITMAP *scrn_buffer;
extern BITMAP *map100_bmp;

extern int level_header[20];
extern int game_map_on;

int a, b, c, d, e, f, x, y;



void set_lift_xyinc(int d, int step) /* used by move lift everywhere */
{
   float speed, angle, xlen, ylen, xinc, yinc;
   speed = lift_steps[d][step] -> val;
   speed /=10;
   xlen = abs( lifts[d] -> x1 - lift_steps[d][step] -> x );
   if (xlen == 0) xlen = .000001;
   ylen = abs( lifts[d] -> y1 - lift_steps[d][step] -> y );
   if (ylen == 0) ylen = .000001;
   angle = atan(ylen/xlen);
   xinc = cos(angle) * speed;
   yinc = sin(angle) * speed;
   if (xlen > ylen)
      lifts[d] -> limit_counter = abs( (int)(xlen / xinc)); /* distance/speed=time! */
   if (xlen <= ylen)
      lifts[d] -> limit_counter = abs( (int)(ylen / yinc)); /* distance/speed=time! */
   lifts[d] -> limit_type = 7; /* step countdown limit type 7 */
   
   if (lifts[d] -> x1  < lift_steps[d][step] -> x) lifts[d]->fxinc= +xinc;
   if (lifts[d] -> x1 == lift_steps[d][step] -> x) lifts[d]->fxinc= 0;
   if (lifts[d] -> x1  > lift_steps[d][step] -> x) lifts[d]->fxinc= -xinc;
   
   if (lifts[d] -> y1  < lift_steps[d][step] -> y) lifts[d]->fyinc= +yinc;
   if (lifts[d] -> y1 == lift_steps[d][step] -> y) lifts[d]->fyinc= 0;
   if (lifts[d] -> y1  > lift_steps[d][step] -> y) lifts[d]->fyinc= -yinc;
}

void draw_lifts()
{
   char msg[80];
   for (d=0; d<level_header[5]; d++)
      {
         int p;
         int x1 = lifts[d]->x1;
         int x2 = lifts[d]->x2;
         int y1 = lifts[d]->y1;
         int y2 = lifts[d]->y2;
         // int mode = lifts[d]->current_step;
         int color = lifts[d]->color;
         if (game_map_on)
            {
               if (y2-y1 > 20) rect(map100_bmp, x1/20, y1/20, x2/20, -1 + y2/20, color);
               else hline(map100_bmp, x1/20, y1/20, x2/20, color); /* single line */
            }
         for (p=0; p<2; p++)
            if (players[p].active)
               {
                  int s1x = players[p].SX;
                  int s1y = players[p].SY;
                  set_clip(scrn_buffer, players[p].SX, players[p].SY,
                       players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);
                  for (a=0; a<10; a++)
                     rect(scrn_buffer, s1x+x1-players[p].WX+a, s1y+y1-players[p].WY+a, s1x+x2-players[p].WX-a, s1y+y2-players[p].WY-a, color + ((9 - a)*16) );
                  rectfill(scrn_buffer, s1x+x1-players[p].WX+a, s1y+y1-players[p].WY+a, s1x+x2-players[p].WX-a, s1y+y2-players[p].WY-a, color );
                  textout_centre(scrn_buffer, font, lifts[d]->lift_name, s1x+((x1+x2)/2)-players[p].WX, s1y+((y1+y2)/2)-players[p].WY-2, color+160);
                }
         set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);


         switch (lifts[d]->limit_type) /* limit type */
            {
               case 5: /* timer wait */
                     sprintf(msg,"%d",lifts[d]->limit_counter) ;
                     for (p=0; p<2; p++)
                        if (players[p].active)
                           textout_centre(scrn_buffer, font, msg, (players[p].SX+lifts[d]->x1 + lifts[d]->x2)/2-players[p].WX+2, players[p].SY+lifts[d]->y1-8-players[p].WY, color+64);
               break;
               case 6: /* prox wait */
                  {
                     int pd = lifts[d]->limit_counter; /* prox dist */
                     int bx1 = lifts[d]->x1 - pd;
                     int by1 = lifts[d]->y1 - pd;
                     int bx2 = lifts[d]->x2 + pd;
                     int by2 = lifts[d]->y2 + pd;
                     for (p=0; p<2; p++)
                        if (players[p].active)
                           {
                              set_clip(scrn_buffer, players[p].SX, players[p].SY,
                               players[p].SX+players[p].SW-1, players[p].SH+players[p].SY-1);

                              rect(scrn_buffer, players[p].SX+bx1-players[p].WX+10,
                                                players[p].SY+by1-players[p].WY+10,
                                                players[p].SX+bx2-players[p].WX-10,
                                                players[p].SY+by2-players[p].WY-10,
                                                color+128);
                           }
                     set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
                  }
              break;
           }


      }  /* end of draw lift */
}

void move_lifts()
{
   for (d=0; d<level_header[5]; d++)
      {
         // int color = lifts[d]->color;
         int p, next_mode = 0;
         lifts[d]->fx += lifts[d]->fxinc; /* xinc */
         lifts[d]->fy += lifts[d]->fyinc; /* yinc */
         for (p=0; p<2; p++)
            if (players[p].active)
               if (d == players[p].player_ride-32)
                  {
                     players[p].PXint = (int)players[p].PX ;
                     players[p].PYint = (int)players[p].PY ;
                     if ((lifts[d]->fxinc > 0) && (!is_right_solid(players[p].PXint, players[p].PYint)) )
                        {
                           players[p].PX  += lifts[d]->fxinc;
                           if (players[p].PX >1980) players[p].PX =1980;
                        }
                     if ((lifts[d]->fxinc < 0) && (!is_left_solid(players[p].PXint, players[p].PYint)) )
                        {
                           players[p].PX  += lifts[d]->fxinc;
                           if (players[p].PX <0) players[p].PX =0;
                        }
                     players[p].PY  = lifts[d]->fy-20; /* align with fy */
                     players[p].PYint = (int)players[p].PY;
                  }
         lifts[d]->x1 = (int)lifts[d]->fx; /* put as int in x1 */
         lifts[d]->y1 = (int)lifts[d]->fy; /* put as int in y1 */
         lifts[d]->x2 = lifts[d]->x1 + (lifts[d]->width*20)-1; /* width  */
         lifts[d]->y2 = lifts[d]->y1 + (lifts[d]->height*20)-1; /* height */

         /* limits */
         switch (lifts[d]->limit_type) /* limit type */
            {
               case 5: /* timer wait */
                       if (--lifts[d]->limit_counter < 0)
                       next_mode = 1;
               break;
               case 6: /* prox wait */
                  {
                     int pd = lifts[d]->limit_counter; /* prox dist */
                     int bx1 = lifts[d]->x1 - pd;
                     int by1 = lifts[d]->y1 - pd;
                     int bx2 = lifts[d]->x2 + pd;
                     int by2 = lifts[d]->y2 + pd;
                     if ( (players[0].PX +10 > bx1) && (players[0].PX +10 < bx2) && (players[0].PY +10 > by1) && (players[0].PY +10 < by2) )
                        next_mode = 1;
                     if ( (players[1].PX +10 > bx1) && (players[1].PX +10 < bx2) && (players[1].PY +10 > by1) && (players[1].PY +10 < by2) )
                        next_mode = 1;
                  }
               break;
               case 7: /* step count */
                       if (--lifts[d]->limit_counter < 0)
                       next_mode = 1;
               break;
            }
         if (next_mode)
            {
               int step = ++lifts[d]->current_step;
               next_mode = 0;
               switch (lift_steps[d][step] -> type)
                  {
                     case 1: /* move */
                        set_lift_xyinc(d, step);
                     break;
                     case 2: /* wait time */
                        lifts[d]->limit_type = 5; /* wait time */
                        lifts[d]->limit_counter = lift_steps[d][step] -> val; /* limit */
                        lifts[d]->fxinc= 0; /* no xinc */
                        lifts[d]->fyinc= 0; /* no yinc */
                     break;
                     case 3: /* wait prox */
                        lifts[d]->limit_type = 6; /* wait prox */
                        lifts[d]->limit_counter = lift_steps[d][step] -> val; /* limit */
                        lifts[d]->fxinc= 0; /* no xinc */
                        lifts[d]->fyinc= 0; /* no yinc */
                     break;
                     case 4: /* move to step 0 */
                           step = lifts[d]->current_step = 0; /* set step 0 */
                           set_lift_xyinc(d, step);
                     break;
                  }
            }
      } /* end of if (active) */
}
