#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <allegro.h>
#include "pm.h"
#include "lift.h"

#ifdef DUMB
   extern AL_DUH_PLAYER *dp;
   extern DUH *myduh;
#endif


void pm_main(void);
void mtextout_centre(BITMAP* , char *txt1, int, int, float, float, int);

void proc_ebullets(void);
void draw_ebullets(void);
void proc_pbullets(void);
void draw_pbullets(void);

// global variables
extern int lines[50][6];
extern float y_adj;

extern float fps;  // frames per second

extern int sync_adjust;

extern struct lift *lifts[20];
extern struct lift_step *lift_steps[20][20];

extern BITMAP *memory_bitmap[NUM_SPRITES];
extern BITMAP *level_2000, *scrn_buffer;
extern BITMAP *map100_bmp, *map100_bkg;
extern PALLETE pallete;
extern SAMPLE *snd[20];
extern int fuse_loop_playing;
extern int phit_loop_playing;
extern int sample_delay[8];

extern int timer_passcount;
extern int no_draw_till_passcount;
extern int draw_frame;

extern int l[100][100];    // level
extern int item[500][16];  // items
extern int Ei[100][32];    // enemies
extern float Ef[100][16];  // enemies
extern int zz[20][NUM_ANS];

// timer variables
extern int level_time;
extern int passcount;

extern int play_level;
extern int start_level;
extern int start_mode;
extern int resume_allowed;

extern int top_menu_sel;

extern int speed;

extern int sound_on;
extern int passcount_timer_fps;
extern int frames_skipped;

extern int fade_count;

extern int max_bullets;
extern int pbullet[50][6];
extern int pm_bullet_collision_box;

extern int e_bullet_active[50], e_bullet_shape[50];
extern int enemy_bullet_colision_window;
extern float e_bullet_x[50], e_bullet_y[50], e_bullet_xinc[50], e_bullet_yinc[50];

extern int bomb[20][5];

extern float itemf[500][4];

extern int level_done;
extern int game_exit;
extern int num_enemy;

// counters and temp string

extern char b_msg[40][80];
extern int bottom_msg;
extern int pop_msg;
extern int pop_msg_count;

extern int map_double; // game map double
extern int map100_x, map100_y;
extern int game_map_on, top_display_on;
extern int top_display_x, top_display_y, top_display_color;
extern int bottom_display_y, bottom_display_color;

extern int map_solid_color, map_semi_color;
extern int map_break_color, map_empty_color;
extern int map_enemy_color , map_bullet_color;
extern int map_item_color, map_player_color;

extern int md; // menu map double
extern int mx;
extern int my;


void event(int ev)
{
   extern int sample_delay[8];
   int x,text_on = 1;
   if (sound_on)
      {
         switch (ev) {

        /*  sample numbers
        0 - player shoots
        1 - d'OH
        2 - bonus
        3 - hiss
        4 - la de da  door, key, exit
        5 - explosion
        6 - grunt 1 shot
        7 - grunt 2 hit
        8 - enemy killed  */


            case  1: play_sample( snd[ 0], 180, 127,  800, 0);
            break;
            case  2: case  4: case  5:
               if (sample_delay[4]+30 < passcount)
                  {
                     sample_delay[4] = passcount;
                     play_sample(snd[4], 200, 127, 1000, 0);
                  }
            break;
            case  6: case  7:  case  8: case  9:
               if (sample_delay[2]+30 < passcount)
                  {
                     sample_delay[2] = passcount;
                     stop_sample(snd[2]); play_sample( snd[2], 200, 127, 1000, 0);
                  }
            break;
            case 11: play_sample( snd[6], 127, 127, 1000, 0); break;
            case 10: case 12:
               if (sample_delay[7]+14 < passcount)
                  {
                      sample_delay[7] = passcount;
                      stop_sample(snd[7]); play_sample( snd[7], 127, 127, 1000, 0);
                  }
            break;
            case 13: play_sample( snd[8], 200, 127, 1200, 0); break;
            case 21: play_sample( snd[1], 255, 127, 1000, 0); break;
            case 22: stop_sample(snd[5]); play_sample( snd[5], 200, 127, 1000, 0); break;
         }
      }
   if (text_on)
      {
         extern char eitype_desc[50][32][40];
         extern int e_killed_type;
         erase_last_bmsg();
         switch (ev) {
            case   1:/* player bullet fired */ break;
            case   2: slide_bmsg();sprintf(b_msg[0], "You got a key!"); bottom_msg = 120; erase_last_bmsg(); break;
            case   3: slide_bmsg();sprintf(b_msg[0], "%d enemies still alive!", num_enemy); bottom_msg = 120; erase_last_bmsg(); break;
            case   4: /* level_done  */ break;
            case   5: slide_bmsg();sprintf(b_msg[0], "Door!"); bottom_msg = 120; erase_last_bmsg(); break;
            case   6: slide_bmsg();sprintf(b_msg[0], "Health Bonus!"); bottom_msg = 120; erase_last_bmsg(); break;
            case   7: slide_bmsg();sprintf(b_msg[0], "Bullet Bonus!"); bottom_msg = 120; erase_last_bmsg(); break;
            case   8: slide_bmsg();sprintf(b_msg[0], "Timer Bonus! "); bottom_msg = 120; erase_last_bmsg(); break;
            case   9: slide_bmsg();sprintf(b_msg[0], "Wahoo! You got a Free Man!"); bottom_msg = 200; erase_last_bmsg(); break;
            case  10: slide_bmsg();sprintf(b_msg[0], "You hit a Mine!"); bottom_msg = 120;erase_last_bmsg(); break;
            case  11: slide_bmsg();sprintf(b_msg[0], "You got shot!"); bottom_msg = 120; erase_last_bmsg(); break;
            case  12: slide_bmsg();sprintf(b_msg[0], "You got hit by %s!", eitype_desc[e_killed_type][0]); bottom_msg = 120; erase_last_bmsg(); break;
            case  13: slide_bmsg();sprintf(b_msg[0], "%s killed!...%d enemies left", eitype_desc[e_killed_type][0],  num_enemy-1);  bottom_msg = 120; erase_last_bmsg(); break;
            case  14: /* cloner cloned something */ break;
            case  15: /* jump  */ break;
            case  16: /* arrow fired */ break;
            case  17: /* green fired */ break;
            case  18: /* cannonball  */ break;
            case  19: /* twirly      */ break;
            case  20: slide_bmsg();sprintf(b_msg[0], "No bullets!"); bottom_msg = 120; erase_last_bmsg(); break;
            case  21: /* you died! */ break;
            case  22: /* explosion */ break;
            case  23: slide_bmsg();sprintf(b_msg[0], "Enemy killed by bomb!"); bottom_msg = 120; bottom_msg = 120; erase_last_bmsg(); break;
            case  24: slide_bmsg();sprintf(b_msg[0], "#%d bomb with %d second fuse",item[x][7]/20, item[x][9]/10 ); bottom_msg = 120+item[x][9]; erase_last_bmsg(); break;
            case  25: slide_bmsg();sprintf(b_msg[0], "Rocket!"); bottom_msg = 120; erase_last_bmsg(); break;
            case  26: slide_bmsg();sprintf(b_msg[0], "you already have perfect health!"); bottom_msg = 120; erase_last_bmsg(); break;
            case  27: slide_bmsg();sprintf(b_msg[0], "you already have perfect bullets!"); bottom_msg = 120; erase_last_bmsg(); break;
            case  28: /* timer full (unused)  */ break;
            case  29: slide_bmsg();sprintf(b_msg[0], "Fruit Bonus"); bottom_msg = 120; erase_last_bmsg();/* fruit bonus */ break;
            case  30: slide_bmsg();sprintf(b_msg[0], "You got a Switch"); bottom_msg = 120; erase_last_bmsg();/*  */ break;
            case  31: slide_bmsg();sprintf(b_msg[0], "Sproingy!"); bottom_msg = 120; erase_last_bmsg();/*  */ break;

         }
      }
}

void pm_main(void) // game loop!
{
   int c,p;
   text_mode(-1);  // masked
   if (!start_mode)
   {
      stimp();
   }
   while (!game_exit) // game loop
   {
      if (start_mode)
      {
         if (load_level(play_level,0))
         {
            passcount = 0;
            frames_skipped = 0; // reset counter
            erase_autoplay(0);
            erase_autoplay(1);
            set_zz(0);
            maps_and_background_fill();
         }
         else
         {
            game_exit = 1;
            resume_allowed = 0;
            goto badload;
         }

         // get start block data 
         float start_x = 1000; // default x pos
         float start_y = 1000; // default y pos
         level_time = 5000;  // default start time
         for (c=0; c<500; c++)  // cycle blocks 
         {
            if (item[c][0] == 5) // get start block
            {
               start_x = itemf[c][0]; // start position x
               start_y = itemf[c][1]; // start position y
               level_time = item[c][8] * 50; // start time
            }
         }   
 
         // reset player data
         for (p=0; p<NUM_PLAYERS; p++)
         {
            players[p].PX  = start_x; // start x position 
            players[p].PY  = start_y; // start y position 
            players[p].num_bullets = 100;
            players[p].LIFE = 100;

            players[p].player_carry = 0;
            players[p].player_ride = 0;
            players[p].left_right = 0;

            players[p].right_speed = players[p].left_speed = 0;
            players[p].jump_count = players[p].fall_count = 0;
         }


         stimp();

          
         // reset sound counters 
         for (c=0; c<8; c++)
         {
            sample_delay[c] = passcount;
         }
       
         timer_passcount = passcount; // sync timer_passcount to actual

         level_done = 0;
         bottom_msg=0;
         pop_msg_count=0;
         clear_keybuf();
         start_mode = 0;

#ifdef DUMB
         start_music();
#endif
      }

//      move_lifts();
//      proc_controllers();
//      player_move();
//      update_animation();
//      enemy_move();
//      enemy_collision();
//      proc_ebullets();
//      proc_pbullets();
//      proc_item_collison();
//      proc_item_move();
//      proc_lit_bomb(draw_frame);
//      proc_lit_rocket(draw_frame);
//      proc_player_carry(draw_frame);
      move_lifts();
      proc_item_collison();
      proc_item_move();
      proc_lit_bomb(draw_frame);
      proc_lit_rocket(draw_frame);
      proc_player_carry(draw_frame);
      proc_controllers();
      player_move();
      update_animation();
      enemy_move();
      enemy_collision();
      proc_ebullets();
      proc_pbullets();

      
      
#ifdef SOUND
      proc_sound();  
#endif
       
      if (passcount <=  timer_passcount)
      {
         draw_frame = 0;
         // printf("passcount %d skipped\n",passcount);
         frames_skipped++;
      } 
      else draw_frame = 1;
      while (passcount > timer_passcount);


      if (draw_frame)
      {
         blit(scrn_buffer, screen, 0,0,0,0, SCREEN_W,SCREEN_H); // screen buffer to screen
         get_new_background();
         draw_items();
         draw_player();
         draw_lifts();
         draw_ebullets();
         draw_pbullets();
         enemy_draw();

         if (--bottom_msg > 0) draw_bottom_msg();
         else bottom_msg = 0;

         if (--pop_msg_count > 0) draw_pop_msg();
         else pop_msg = 0;

         if (top_display_on) draw_top_display();
         if (game_map_on) draw_map();
      }

      // only count down timer if at least one player is active and not paused
      for (p=0; p<NUM_PLAYERS; p++)
      {
        if ((players[p].active) && (!players[p].paused))
         {
            level_time--;
            break;
         }
      }

      if (level_time < 40) 
      {
         event(21);
         stretch_text("Time", "Up!", 10);

         // all players die
         int p;
         for (p=0; p<NUM_PLAYERS; p++) 
         {
            if (players[p].active)
            {
               players[p].LIFE = -1;
            }   
         }  

         // reset level_time 
         for (c=0; c<500; c++)  // cycle blocks 
         {
            if (item[c][0] == 5) // get start block
            {
               level_time = item[c][8] * 50; // start time
            }
         }   

      }       
      
      for (p=0; p<NUM_PLAYERS; p++)
      {
         if (players[p].active)
         {
            if (players[p].LIFE>100) players[p].LIFE = 100;

            if (players[p].LIFE < 0)
            {
               event(21);
               if (--players[p].LIVES < 0)
               {
                  stretch_text_p("Game", "Over!", 14, p);
               //   rest(1000);


                  // if both players active 
     //             if ( (players[0].active) && (players[1].active) )
      //            {
                     // restart this player instantly
                     players[p].active = 0;
                     players[p].paused = 1;
                     players[p].paused_passcount = 40;
                     players[p].LIFE = 100;
                     players[p].LIVES = 5;
        //          }
          //        else
            //      {
                     // if one player only and he dies send to menu
                    
  //                   resume_allowed = 0;
    //                 top_menu_sel = 3; // not resume
      //               game_exit = 1;
        //          }  
                   
               }
               else
               {
                  stretch_text_p("You", "Died!", 10, p);
                  players[p].active = 0;
                  players[p].paused = 1;
                  players[p].paused_passcount = 40;

                  players[p].LIFE = 100;
               }
            }
         }
      }
      if (level_done)
      {
         if (sound_on)
         {
            stop_sample( snd[3] );
#ifdef DUMB
            al_stop_duh(dp);
            dp = NULL;
#endif
         }
         stretch_text("Level", "Done!", 9);
         play_level++;
         start_mode = 1;
      }
   } // end of while (!game_exit)

   badload:
   if (resume_allowed) top_menu_sel = 4; // resume
   if (sound_on)
   {
      stop_sample( snd[3] ); // fuse hiss
      fuse_loop_playing = 0;

#ifdef DUMB
      al_stop_duh(dp);
      dp = NULL;
#endif

   }
   stamp();
   text_mode(0);  // normal
   clear_keybuf();
}

