#include <stdio.h>
#include "pm.h"
#include "lift.h"

extern BITMAP *memory_bitmap[NUM_SPRITES];
extern BITMAP *scrn_buffer;
extern BITMAP *map100_bmp;

extern int item[500][16];  // items
extern float itemf[500][4];
extern int zz[20][NUM_ANS];

extern float y_adj;
extern int passcount;
extern int timer_passcount;
extern int no_draw_till_passcount;
extern int game_map_on;

void player_move()
{
   int a,p;
   for (p=0; p<NUM_PLAYERS; p++)
   {
      if ((players[p].active) && (!players[p].paused))
      {
         // process ex_jump (sproingy!)
         if ((players[p].ex_jump) && (!players[p].jump_count))
         {
            players[p].ex_jump = 0;
            players[p].jump_sinc=.05;
            players[p].pmovey = 5;
         }

         if (!((players[p].player_carry) && (item[players[p].player_carry-1][0] == 98)))
         {
            //  sprintf(msg, "player %d here" ,p  );
            // textout(screen, font, msg, 230,70+8*p, 10);

            if (players[p].left)
            {
               players[p].left_right = 0;
               if (players[p].left_speed < players[p].initial_x_speed) players[p].left_speed = players[p].initial_x_speed;
               else
               {
                  players[p].left_speed += players[p].accel;
                  if (players[p].left_speed > players[p].max_x_speed) players[p].left_speed = players[p].max_x_speed;
               }
            }
            else
            {
               players[p].left_speed -= players[p].de_accel;
               if (players[p].left_speed < 0) players[p].left_speed = 0;
            }
            if (players[p].right)
            {
               players[p].left_right = 1;
               if (players[p].right_speed < players[p].initial_x_speed) players[p].right_speed = players[p].initial_x_speed;
               else
               {
                  players[p].right_speed += players[p].accel;
                  if (players[p].right_speed > players[p].max_x_speed) players[p].right_speed = players[p].max_x_speed;
               }
            }
            else
            {
               players[p].right_speed -= players[p].de_accel;
               if (players[p].right_speed < 0) players[p].right_speed = 0;
            }
         
            players[p].p_xmove = players[p].right_speed - players[p].left_speed;
            players[p].PXint = (int)(players[p].PX + players[p].p_xmove);
            players[p].PYint = (int)players[p].PY;
            // check for player being pushed by lift
            a = (is_left_solid(players[p].PXint ,players[p].PYint));
            if ( a > 31 )
            {
               players[p].p_xmove += lifts[a-32]->fxinc + players[p].left_speed;
               players[p].left_speed=0;
            }
            a = is_right_solid(players[p].PXint ,players[p].PYint);
            if ( a > 31 )
            {
               players[p].p_xmove += lifts[a-32]->fxinc - players[p].right_speed;
               players[p].right_speed = 0;
            }
            // check if trying to move through wall
            if ((players[p].p_xmove > 0) && (!is_right_solid(players[p].PXint + (int) players[p].p_xmove,players[p].PYint)) )
            {
               players[p].PX  += players[p].p_xmove;
               if (players[p].PX >1980) players[p].PX =1980;
               players[p].PXint  = (int)players[p].PX ;
            }
            if ((players[p].p_xmove < 0) && (!is_left_solid(players[p].PXint + (int) players[p].p_xmove,players[p].PYint)) )
            {
               players[p].PX  += players[p].p_xmove;
               if (players[p].PX <0) players[p].PX =0;
               players[p].PXint  = (int)players[p].PX ;
            }

//---------------------- Y MOVEMENT ---------------------------------

            // check if in the middle of a jump
            if (players[p].jump_count)
            {
               players[p].jump_count -= players[p].jump_sinc;
               if (players[p].jump_count < .1)
               {
                  players[p].jump_count = 0;
                  players[p].fall_count = 1.57;
               }
               else
               {
                  if (!players[p].jump) players[p].jump_count -= (players[p].jump_sinc*4); // jump released
                  if (is_up_solid(players[p].PXint , players[p].PYint, 1, 0))
                  {
                     players[p].jump_count = 0;
                     players[p].fall_count = 1.57;
                  }
                  else players[p].PY  -= (sin(players[p].jump_count) * players[p].pmovey);
               }
            }
            else // not jump
            {
               if (players[p].fall_count)
               {
                  players[p].fall_count -= players[p].fall_sinc;
                  if (players[p].fall_count < .1) players[p].fall_count = .1;
                  players[p].PY  += (sin(1.57 - players[p].fall_count) * players[p].pmovey);
                  players[p].PYint = (int)players[p].PY ;
                  a = is_down_solid(players[p].PXint ,players[p].PYint, 1);
                  if (a == 1)
                  {
                     players[p].fall_count = 0;
                     players[p].PY  -= fmod (players[p].PY , 20); // align with floor
                  }
                  if ((a > 31) && (a < 1024)) // on lift
                  {
                     players[p].fall_count = 0;
                     players[p].player_ride = a; // lift num
                  }
                  if (a > 1023) // on line
                  {
                     players[p].fall_count = 0;
                     players[p].player_ride = a;
                     players[p].PY  = y_adj; // align with line
                  }
               }
               else // not jump or fall
               {
                  a = is_down_solid(players[p].PXint ,players[p].PYint , 1); // on lift?
                  if ((a > 31) && (a < 1024)) // lift below
                  {
                     players[p].player_ride = a ; // number of shape he's riding
                     if (lifts[a-32]->fyinc < 0) // yinc (up)
                     {
                        players[p].PYint = (int) (players[p].PY  + lifts[a-32]->fyinc);
                        if (is_up_solid(players[p].PXint , players[p].PYint , 1, 0))  // hit ceiling?
                        {
                           players[p].player_ride = 0; // fall off lift
                           players[p].fall_count = 1.57;
                           players[p].PY  += 5; // set y so he falls
                        }
                     }
                     if (lifts[a-32]->fyinc > 0) // yinc (down)
                     {
                        players[p].PYint = (int)(players[p].PY  + lifts[a-32]->fyinc);
                        if (is_down_solid(players[p].PXint , players[p].PYint , 0))  // floor below?
                        {
                           players[p].player_ride = 0;   // off lift
                           players[p].fall_count = 1.57;
                           players[p].PY  -= 5; // set y
                        }
                     }
                  }
                  if (a > 1023) // line below
                  {
                     players[p].player_ride = a ; // number of line he's on
                     players[p].PY  = y_adj;
                  }
                  if (a == 0)  // start fall?
                  {
                     players[p].player_ride = 0;
                     players[p].fall_count = 1.57;
                  }
                  if ((a) && (players[p].jump)) // check if jump pressed
                  {
                     players[p].player_ride = 0;
                     players[p].jump_count=1.57;
                     event(15);
                  }
               }
            } // end of else not jump and end of Y_MOVE
         } // end of if ! ride rocket

         players[p].PXint = (int)players[p].PX ;
         players[p].PYint = (int)players[p].PY ;
      }


      if ((!players[p].active) && (players[p].paused))
      {
         if (players[p].paused_passcount > 0)
         {
            players[p].paused_passcount--;
         }
         else // frozen done !!
         {
            if (press_any_p_rt(p))
            {
               players[p].paused = 0;
               players[p].active = 1;
               players[p].num_bullets = 100;
               players[p].LIFE = 100;
               int c;
               for (c=0; c<500; c++)  // get start and time
               {
                  if (item[c][0] == 5)
                  {
                     players[p].PX  = itemf[c][0];
                     players[p].PY  = itemf[c][1];
                  }
               }
            }
         }
      }
   }
}
void draw_player()
{
   int p,x,y;

#ifdef NETPLAY
   if (1) // temp debug some stuff
   {
      char msg[180];
      int temp = text_mode(0);
      extern int passcount_timer_fps;
      extern int fps;
      extern int frames_skipped;

      sprintf(msg, "passcount_timer_fps=%4d        passcount=%d", passcount_timer_fps, passcount);
      textout(scrn_buffer, font, msg, 30,40, 10);

      sprintf(msg, "                fps=%4d  timer_passcount=%d ", fps, timer_passcount );
      textout(scrn_buffer, font, msg, 30,48, 10);

      sprintf(msg, "frames_skipped=%4d ", frames_skipped );
      textout(scrn_buffer, font, msg, 30,56, 10);

/*      sprintf(msg, "passcount=%d  no_draw_till_p=%d ", passcount, no_draw_till_passcount );
      textout(scrn_buffer, font, msg, 30,30, 10);

      textout(scrn_buffer, font, "Player 1", 30,70, 10);
      sprintf(msg, "api_read=%d  api_write=%d ", players[0].api_read, players[0].api_write );
      textout(scrn_buffer, font, msg, 30,80, 10+32);
      sprintf(msg, "comp_move=%d  old_comp_move=%d ", players[0].comp_move, players[0].old_comp_move );
      textout(scrn_buffer, font, msg, 30,89, 10+32);

      textout(scrn_buffer, font, "Player 2", 30,100, 8);
      sprintf(msg, "api_read=%d  api_write=%d ", players[1].api_read, players[1].api_write );
      textout(scrn_buffer, font, msg, 30,110, 8+32);
      sprintf(msg, "comp_move=%d  old_comp_move=%d ", players[1].comp_move, players[1].old_comp_move );
      textout(scrn_buffer, font, msg, 30,119, 8+32);
  */
      text_mode(temp);
   }
#endif

   for (p=0; p<NUM_PLAYERS; p++)
   {
      int AX = players[p].SX + (int)players[p].PX - players[p].WX;
      int AY = players[p].SY + (int)players[p].PY - players[p].WY;

      if ((players[p].active) && (!players[p].paused))
      {

         if (0) // temp debug some stuff
         {
            char msg[80];
            int temp = text_mode(0);
            textout(scrn_buffer, font, "                      ", 30,30+8*p, 9);
            sprintf(msg, "WX=%d  WY=%d " ,players[p].WX, players[p].WY );
            textout(scrn_buffer, font, msg, 30,30+8*p, 9);
            textout(scrn_buffer, font, "                      ", 30,50+8*p, 10);
            sprintf(msg, "PX=%d  PY=%d " ,players[p].PXint, players[p].PYint );
            textout(scrn_buffer, font, msg, 30,50+8*p, 10);
            textout(scrn_buffer, font, "                      ", 30,70+8*p, 10);
            sprintf(msg, "SX=%d  SY=%d " ,players[p].SX, players[p].SY );
            textout(scrn_buffer, font, msg, 30,70+8*p, 10);
            sprintf(msg, "pxF=%f  pyF=%f " ,players[p].PX, players[p].PY );
            textout(scrn_buffer, font, msg, 30,110+8*p, 9);
            text_mode(temp);
         }

         int b = 9-(3*p);
         if (players[p].up)   b=10-(3*p);
         if (players[p].down) b=11-(3*p);
         x = (players[p].PXint /4) % zz[4][b];
         if ((players[p].jump_count) || (players[p].fall_count)) x = 0;
         if ((players[p].player_ride) && (players[p].right_speed<.5) && (players[p].left_speed<.5)) x = 0;
         if ((players[p].player_carry) && (item[players[p].player_carry-1][0] == 98)) x = 0;
         y = zz[x+5][b];

         // draw on screen 1
         if ((players[0].active) && (players[0].local_draw)) 
         {
            set_clip(scrn_buffer, players[0].SX, players[0].SY, players[0].SX+players[0].SW-1, players[0].SH+players[0].SY-1);
            AX = players[0].SX + (int)players[p].PX - players[0].WX;
            AY = players[0].SY + (int)players[p].PY - players[0].WY;
            if (players[p].left_right)
               draw_sprite(scrn_buffer, memory_bitmap[y], AX, AY);
            else
               draw_sprite_h_flip(scrn_buffer, memory_bitmap[y], AX, AY);
         }

         // draw on screen 2
         if ((players[1].active) && (players[1].local_draw)) 
         {
            set_clip(scrn_buffer, players[1].SX, players[1].SY, players[1].SX+players[1].SW-1, players[1].SH+players[1].SY-1);
            AX = players[1].SX + (int)players[p].PX - players[1].WX;
            AY = players[1].SY + (int)players[p].PY - players[1].WY;
            if (players[p].left_right)
               draw_sprite(scrn_buffer, memory_bitmap[y], AX, AY);
            else
               draw_sprite_h_flip(scrn_buffer, memory_bitmap[y], AX, AY);
            set_clip(scrn_buffer, 0,0,SCREEN_W,SCREEN_H);
         }

         if (game_map_on)
         {
         //   int color = 74-p*2; // red (76) for p1 (0) -- purple (74) for p2 (1)
            int color = 72+p*2; // red (76) for p1 (0) -- purple (74) for p2 (1)            //  rectfill(map100_bmp,((players[0].PXint +10)/20)-1, (players[0].PYint /20)-1,((players[0].PXint +10)/20)+1, (players[0].PYint /20)+1,152);
            if ((passcount % 20) < 10 )
            {
               putpixel(map100_bmp,(players[p].PXint +10)/20+1, players[p].PYint/20,color);
               putpixel(map100_bmp,(players[p].PXint +10)/20-1, players[p].PYint/20,color);
               putpixel(map100_bmp,(players[p].PXint +10)/20,   players[p].PYint/20+1,color);
               putpixel(map100_bmp,(players[p].PXint +10)/20,   players[p].PYint/20-1,color);
            }
            if ((passcount % 20) > 9 )
            {
               putpixel(map100_bmp,(players[p].PXint +10)/20+1, players[p].PYint/20+1,color);
               putpixel(map100_bmp,(players[p].PXint +10)/20-1, players[p].PYint/20-1,color);
               putpixel(map100_bmp,(players[p].PXint +10)/20+1, players[p].PYint/20-1,color);
               putpixel(map100_bmp,(players[p].PXint +10)/20-1, players[p].PYint/20+1,color);
            }
            putpixel(map100_bmp,(players[p].PXint +10)/20, players[p].PYint /20,color-64);
         }
      }
   }
}

