#include "pm.h"
int WX, WY;

extern BITMAP *scrn_buffer;
extern int fuse_loop_playing;

void set_screens(int screen_split_axis)
{
   // find all players that are active and have local draw set
   // store their player indexes in local_player1_index and local_player2_index
   // and the number of local players in num_local players
   // then:
/*

   player

   for (p=0; p<NUM_PLAYERS; p++)\
   {
      if players[p].active  


   if (num_local_players == 1)
   {
      // set_local_player1 to full screen and  
   
     
     
   }  

*/

   static int split=0; // retain value over repeated function calls; initialized only once 
   int b = 16; // border width
// if (screen_split_axis == 0) split retains its last value 
   if (screen_split_axis == 1) split = 1;
   if (screen_split_axis == 2) split = 2;

//   if ((players[0].active) && (!players[1].active)) // set p1 full screen 
   if ( !((players[1].active) && (players[1].local_draw)) &&   
         ((players[0].active) && (players[0].local_draw)) )
   {
      players[0].SX = b; // (position of origin on screen) 
      players[0].SY = b; 
      players[0].SW = SCREEN_W-b*2;
      players[0].SH = SCREEN_H-b*2;
   }

//   if ((!players[0].active) && (players[1].active)) // set p2 full screen 
   if ( !((players[0].active) && (players[0].local_draw)) &&   
         ((players[1].active) && (players[1].local_draw)) )
   {
      players[1].SX = b; // (position of origin on screen) 
      players[1].SY = b; 
      players[1].SW = SCREEN_W-b*2;
      players[1].SH = SCREEN_H-b*2;
   }

//   if ((players[0].active) && (players[1].active)) // set both 
   if ( ((players[0].active) && (players[0].local_draw)) &&   
         ((players[1].active) && (players[1].local_draw)) )
   {
      if (split == 1) // split x-axis 
      {
          players[0].SX = b; 
          players[0].SY = b; 
          players[0].SW = SCREEN_W/2-b*2;
          players[0].SH = SCREEN_H-b*2;
       
          players[1].SX = b+SCREEN_W/2;
          players[1].SY = b;  
          players[1].SW = SCREEN_W/2-b*2;
          players[1].SH = SCREEN_H-b*2;
       }
      if (split == 2) // split y-axis 
      {
          players[0].SX = b;
          players[0].SY = b;
          players[0].SW = SCREEN_W-b*2;
          players[0].SH = SCREEN_H/2-b*2;
       
          players[1].SX = b;
          players[1].SY = b+SCREEN_H/2;
          players[1].SW = SCREEN_W-b*2;
          players[1].SH = SCREEN_H/2-b*2;
      }
   }
}


extern BITMAP *memory_bitmap[NUM_SPRITES];

void frame_and_title(void)
{
    BITMAP *pm_title;
    BITMAP *temp_title;
    int x,y;

    pm_title = create_bitmap(280,20);
    temp_title = create_bitmap(140,8);
    clear(pm_title);
    clear(temp_title);

      textout_centre(temp_title, font, "Purple Martians!", 70,0,200);
      for (x=0; x<5; x++)
         for (y=0; y<5; y++)
            stretch_sprite(pm_title, temp_title, x,y,280,16);
      textout_centre(temp_title, font, "Purple Martians!", 70,0,136);
      stretch_sprite(pm_title, temp_title, 1,1,280,16);
      stretch_sprite(pm_title, temp_title, 1,3,280,16);
      stretch_sprite(pm_title, temp_title, 3,1,280,16);
      stretch_sprite(pm_title, temp_title, 3,3,280,16);
      textout_centre(temp_title, font, "Purple Martians!", 70,0,8);
      stretch_sprite(pm_title, temp_title, 2,2,280,16);

   for (x=0;x<16;x++)
      rect(screen, x,x, SCREEN_W-1-x, SCREEN_H-1-x, 8+(x*16) );

   blit(pm_title, screen,0,0,(SCREEN_W/2)-140,20,280,20);


   textout(screen, font, "Player 1",              12, 40,  8);
   draw_sprite(screen, memory_bitmap[401],        32, 50);
   blit(memory_bitmap[32], screen, 0, 0,          34, 70, 20, 20);
   if (players[0].active)
   {
      char msg[80];
      textout_centre(screen, font, "Enabled",        44, 92,  11);

      sprintf(msg, "Lives:%d",players[0].LIVES);
      textout_centre(screen, font, msg,              44, 100, 11);

      sprintf(msg, "Life:%0.0f",players[0].LIFE);
      textout_centre(screen, font, msg,              44, 108, 11);

      sprintf(msg, "Shot:%d",players[0].num_bullets);
      textout_centre(screen, font, msg,              44, 116, 11);

      sprintf(msg, "Hits:%d",players[0].num_hits);
      textout_centre(screen, font, msg,              44, 124, 11);
   }
   else
   {
      textout_centre(screen, font, "Disabled",       44, 92,  14);
   }

   textout(screen, font, "Player 2",              SCREEN_W-75, 40, 10);
   draw_sprite_h_flip(screen, memory_bitmap[812], SCREEN_W-54, 50 );
   blit(memory_bitmap[32], screen, 0, 0,          SCREEN_W-56, 70, 20, 20);
   if (players[1].active)
   {
      char msg[80];
      textout_centre(screen, font, "Enabled",     SCREEN_W-43, 92, 11);
      sprintf(msg, "Lives:%d",players[1].LIVES);
      textout_centre(screen, font, msg,           SCREEN_W-43, 100, 11);

      sprintf(msg, "Life:%0.0f",players[1].LIFE);
      textout_centre(screen, font, msg,           SCREEN_W-43, 108, 11);

      sprintf(msg, "Shot:%d",players[1].num_bullets);
      textout_centre(screen, font, msg,           SCREEN_W-43, 116, 11);

      sprintf(msg, "Hits:%d",players[1].num_hits);
      textout_centre(screen, font, msg,           SCREEN_W-43, 124, 11);
   }
   else
   {
      textout_centre(screen, font, "Disabled",    SCREEN_W-43, 92, 14);
   }

   text_mode(-1);

#ifdef MV
   textout_centre(screen, font, "Beta Version 5.021224", SCREEN_W/2,SCREEN_H-9, 15);
#else
   textout_centre(screen, font, "Version 5.0", SCREEN_W/2,SCREEN_H-9,15);
#endif
   destroy_bitmap(pm_title);
   destroy_bitmap(temp_title);
   text_mode(0);
}

void mtextout(BITMAP *dbmp, char *txt1, int x, int y, float x_scale, float y_scale, int col)
{
   /*
      this function will
      determine the size of bitmap needed by the length of the string
      determine the size of the destination
      create the bitmap
      draw text on it
      stretch blit to screen
   */
      BITMAP *temp;
      int sw = strlen(txt1) * 8;
      int sh = 8;
      int dw = sw * (int)x_scale;
      int dh = sh * (int)y_scale;

      temp = create_bitmap(sw,sh);
      clear(temp);
      textout(temp, font, txt1, 0, 0, col);
   /*   stretch_blit(temp, dbmp, 0, 0, sw, sh, x, y, dw, dh); */
      stretch_sprite(dbmp, temp, x, y, dw, dh);

      destroy_bitmap(temp);
}
void mtextout_centre(BITMAP *dbmp, char *txt1, int x, int y, float x_scale, float y_scale, int col)
{
   /*
      this function will
      determine the size of bitmap needed by the length of the string
      determine the size of the destination
      create the bitmap
      draw text on it
      stretch blit to screen
   */
      BITMAP *temp;
      int sw = strlen(txt1) * 8;
      int sh = 8;
      int dw = sw * (int)x_scale;
      int dh = sh * (int)y_scale;

      temp = create_bitmap(sw,sh);
      clear(temp);
      textout(temp, font, txt1, 0, 0, col);
   /*   stretch_blit(temp, dbmp, 0, 0, sw, sh, x, y, dw, dh); */
      stretch_sprite(dbmp, temp, x-dw/2, y, dw, dh);

      destroy_bitmap(temp);
}
void stretch_text(char *txt1, char* txt2, int col)
{
      BITMAP *btemp;
      int ns = 8; /* num of shadows */
      int ci = 16; /* color inc  */
      int st = 6;  /* skip step between 1st and 2nd color  */
      int a;

      int bxw, bxh, x_double, y_double;
      int border_x, border_y, final_x, final_y;

      int num_lines = 2;
      int llen;


      if (strlen(txt2)==0) num_lines = 1;

      if ( strlen(txt2) > strlen(txt1) )
         llen = strlen(txt2);
      else
         llen = strlen(txt1);

      bxw = llen*8;
      bxh = num_lines*8; /* only one line for now */

      x_double = SCREEN_W/bxw;

      x_double /=2;

      y_double = x_double*2;

      border_x = (SCREEN_W-(bxw*x_double))/2;
      border_y = (SCREEN_H-(bxh*y_double))/2;

      final_x = SCREEN_W-border_x*2;
      final_y = SCREEN_H-border_y*2;

      btemp = create_bitmap(bxw, bxh);
      clear(btemp);

      for (a = ns; a >= 0; a--)
         {
            int b = col+a*ci;
            if (a) b = col+( (a+st) * ci); /* not first color */
            textout_centre(btemp, font, txt1, bxw/2, 0, b);
            textout_centre(btemp, font, txt2, bxw/2, 8, b);
            stretch_sprite(screen, btemp, border_x+a, border_y+a, final_x, final_y);
         }
      destroy_bitmap(btemp);

//      btemp = create_bitmap(248, 8);
//      clear(btemp);
//      textout(btemp, font, "...press any key to continue...", 0, 0, 5);
//
//      x_double = SCREEN_W/248;
//      if (x_double < 1) x_double = 1;
//      y_double = x_double;
//
//      stretch_sprite(screen, btemp, (SCREEN_W-(x_double*248))/2, SCREEN_H-border_y+10, x_double*248, y_double*8);
//
//      destroy_bitmap(btemp);

      rest(1200);
}

void stretch_text_p(char *txt1, char* txt2, int col, int p)
{
      BITMAP *btemp;
      int ns = 8; /* num of shadows */
      int ci = 16; /* color inc  */
      int st = 6;  /* skip step between 1st and 2nd color  */
      int a;

      int bxw, bxh, x_double, y_double;
      int border_x, border_y, final_x, final_y;

      int num_lines = 2;
      int llen;

      int SX = players[p].SX;  // (POSITION)
      int SY = players[p].SY;

      int SW = players[p].SW;  // (SIZE)
      int SH = players[p].SH;

     if (strlen(txt2)==0) num_lines = 1;

      if ( strlen(txt2) > strlen(txt1) )
         llen = strlen(txt2);
      else
         llen = strlen(txt1);

      bxw = llen*8;
      bxh = num_lines*8; /* only one line for now */

      x_double = SW/bxw;

      x_double /=2;

      y_double = x_double;

      border_x = (SW-(bxw*x_double))/2;
      border_y = (SH-(bxh*y_double))/2;

      final_x = SW-border_x*2;
      final_y = SH-border_y*2;

      btemp = create_bitmap(bxw, bxh);
      clear(btemp);

      for (a = ns; a >= 0; a--)
         {
            int b = col+a*ci;
            if (a) b = col+( (a+st) * ci); /* not first color */
            textout_centre(btemp, font, txt1, bxw/2, 0, b);
            textout_centre(btemp, font, txt2, bxw/2, 8, b);
            stretch_sprite(scrn_buffer, btemp, SX+border_x+a, SY+border_y+a, final_x, final_y);
         }
      destroy_bitmap(btemp);

      btemp = create_bitmap(280, 8);
      clear(btemp);
      textout(btemp, font, "...press any control to continue...", 0, 0, 5);

      x_double = SW/280;
      if (x_double < 1) x_double = 1;
      y_double = x_double;

      stretch_sprite(scrn_buffer, btemp, SX+(SW-(x_double*248))/2, SY+SH-border_y+10, x_double*248, y_double*8);

      destroy_bitmap(btemp);

}


extern BITMAP *level_2000, *scrn_buffer;
extern BITMAP *map100_bmp, *map100_bkg;
extern int zz[20][NUM_ANS];
extern int l[100][100];    /* level */

extern int WX, WY;
extern int game_map_on;

extern int map_double; /* game map double */
extern int map100_x, map100_y;
extern int game_map_on, top_display_on;
extern int top_display_x, top_display_y, top_display_color;
extern int bottom_display_y, bottom_display_color;

extern int map_solid_color, map_semi_color;
extern int map_break_color, map_empty_color;
extern int map_enemy_color , map_bullet_color;
extern int map_item_color, map_player_color;

extern int md; /* menu map double */
extern int mx;
extern int my;


void next_map_mode()
{
   if (game_map_on)
      {
         game_map_on = 0;
         if (map100_x < 40) map100_x = SCREEN_W - map_double*100;
         else map100_x = 0;
         if (map100_y < 40) map100_y = SCREEN_H - map_double*100;
         else map100_y = 0;
         if ((SCREEN_W == 320) && (map100_y < 20)) map100_y = 20;
      }
   else game_map_on = 1;
}

void draw_map()
{
   if ( (players[0].PX -WX) < SCREEN_W/2 - 20) map100_x = SCREEN_W - map_double*100;
   if ( (players[0].PX -WX) > SCREEN_W/2 + 20) map100_x = 0;
   if ( (players[0].PY -WY) < SCREEN_H/2 - 20) map100_y = SCREEN_H - map_double*100;
   if ( (players[0].PY -WY) > SCREEN_H/2 + 20) map100_y = 0;
   if ((SCREEN_W == 320) && (map100_y < 20)) map100_y = 20;
   stretch_sprite(scrn_buffer, map100_bmp, map100_x, map100_y, map_double*100, map_double*100);
   blit(map100_bkg, map100_bmp, 0,0,0,0,100,100);
}

void old_draw_top_display(void)
   {
      int ho = 69;
      char msg[80];
      extern int level_time;
      extern int play_level;
      sprintf(msg,"Level:%-3d",play_level) ;
      textout(scrn_buffer, font, msg, top_display_x + 2, top_display_y + 2, top_display_color);
      sprintf(msg,"Lives:%-1d",players[0].LIVES) ;
      textout(scrn_buffer, font, msg, top_display_x + 2, top_display_y + 11, top_display_color);
      sprintf(msg,"Health") ;
      textout(scrn_buffer, font, msg, top_display_x + ho+2, top_display_y + 2, top_display_color);
      rectfill (scrn_buffer, top_display_x+ho, top_display_y + 10, top_display_x + ho+50, top_display_y +17, 10); /*  red   */
      rectfill (scrn_buffer, top_display_x+ho, top_display_y + 10, top_display_x + ho+((int)(players[0].LIFE/2)), top_display_y +17, 11); /*  green */

      sprintf(msg,"Time:%-3d",level_time/50);
      textout(scrn_buffer, font, msg, top_display_x + 124, top_display_y + 2, top_display_color);
      sprintf(msg,"Shot:%-3d",players[0].num_bullets);
      textout(scrn_buffer, font, msg, top_display_x + 124, top_display_y + 11, top_display_color);
   }
void draw_top_display(void)
{
   int a;
   int tdx, tdy;
   char msg[80];
   extern int level_time;
   extern int play_level;

   int p;
   for (p=0; p<2; p++)
   {
      if (players[p].active)
      {
         tdx = players[p].SX + players[p].SW/2;
         tdy = players[p].SY -18;

         rectfill (scrn_buffer, tdx+07, tdy + 4, tdx+07 + 50, tdy +11, 10); /*  red   */
         rectfill (scrn_buffer, tdx+07, tdy + 4, tdx+07 + ((int)(players[p].LIFE/2)), tdy +11, 11); /*  green */
         rect     (scrn_buffer, tdx+07 -1, tdy + 3, tdx+07 + 51, tdy +12, 15); /*  white */

         sprintf(msg,"Shot:%-3d",players[p].num_bullets);
         textout(scrn_buffer, font, msg, tdx-70, tdy+4, top_display_color);

         for (a=0; a<players[p].LIVES; a++)
            stretch_sprite(scrn_buffer, memory_bitmap[844-443*(!p)], tdx+65+(a*12), tdy+4, 10,10);
      }
   }
   if ((players[0].SX == players[1].SX) && (players[0].SW == players[1].SW))
   {
      tdx = 40;
      tdy = SCREEN_H/2-11;
   }
   if ((players[0].SY == players[1].SY) && (players[0].SH == players[1].SH))
   {
      tdx = SCREEN_W/2;
      tdy = 0;
   }
   if ((players[0].active == 0) || (players[1].active == 0))
   {
      tdx = SCREEN_W/2;
      tdy = 16;
   }

   for (a=0; a<15; a++)
      rect(scrn_buffer, tdx-40+a, tdy+a, tdx+40-a, tdy+22-a, 10+(2*(a/2)*16)); /*  red   */

   rect(scrn_buffer, tdx-40, tdy, tdx+40, tdy+22, 10); /*  red   */
   sprintf(msg,"Level:%d",play_level) ;
   textout_centre(scrn_buffer, font, msg, tdx, tdy+4, top_display_color);
   sprintf(msg,"Time:%d",level_time/50);
   textout_centre(scrn_buffer, font, msg, tdx, tdy+12, top_display_color);

#ifdef FPS_DISPLAY
   extern int fps;
   sprintf(msg, "fps=%4d ", fps);
   textout_centre(scrn_buffer, font, msg, tdx, tdy+30, top_display_color);
   extern int passcount;
   extern int frames_skipped;
   if (passcount)
   { 
      sprintf(msg, "skipped=%4d %%",((frames_skipped*100)/passcount));
      textout_centre(scrn_buffer, font, msg, tdx, tdy+38, top_display_color);
   }
#endif

}


extern float steps;
void stamp(void)   /* stretch map animated shrinkage of play screen to map */
{

       add_eilp_to_l2000();
       WX = (int)players[0].PX  - (SCREEN_W/2)-10; /* set window from players[0] -> PX ,players[0] -> PY  */
       WY = (int)players[0].PY  - (SCREEN_H/2)-10;
       if (WX < 0) WX = 0;
       if (WX > 1999 - SCREEN_W) WX = 1999 - SCREEN_W;
       if (WY > 1999 - SCREEN_H) WY = 1999 - SCREEN_H;
       if (WY < 0) WY = 0;
   
      if (1)
         {
            int x;
            float inc1 = (0-WX)/steps;
            float inc2 = (0-WY)/steps;
            float inc3 = (2000-SCREEN_W)/steps;
            float inc4 = (2000-SCREEN_H)/steps;
            float inc5 = (mx-0)/steps;
            float inc6 = (my-0)/steps;
            float inc7 = (md*100-SCREEN_W)/steps;
            float inc8 = (md*100-SCREEN_H)/steps;


            float s1 = WX;
            float s2 = WY;
            float s3 = SCREEN_W;
            float s4 = SCREEN_H;
            float s5 = 0;
            float s6 = 0;
            float s7 = SCREEN_W;
            float s8 = SCREEN_H;
            BITMAP *ht;

            ht = create_bitmap(SCREEN_W, SCREEN_H);

            for (x = 0; x<=steps; x++)
               {

                  stretch_blit(level_2000, ht,(int)s1,(int)s2,(int)s3,(int)s4,(int)s5,(int)s6,(int)s7,(int)s8);

                  rectfill(ht,(int)(s5-inc5), (int)s6     , (int)(s5-inc5+s7-inc7), (int)(s6-inc6),         0);
                  rectfill(ht,(int)(s5-inc5), (int)(s6+s8)  , (int)(s5-inc5+s7-inc7), (int)(s6-inc6+s8-inc8), 0);

                  rectfill(ht,(int)(s5-inc5), (int)(s6-inc6), (int)s5,  (int)(s6-inc6+s8-inc8), 0);
                  rectfill(ht,(int)(s5+s7)  , (int)(s6-inc6), (int)(s5-inc5+s7-inc7), (int)(s6-inc6+s8-inc8), 0);

                  blit(ht, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

               /*   rest(x/steps*5); */

                  s1+=inc1;
                  s2+=inc2;
                  s3+=inc3;
                  s4+=inc4;
                  s5+=inc5;
                  s6+=inc6;
                  s7+=inc7;
                  s8+=inc8;


               }

       }
}
void stimp(void)   /* stretch map animated growage of map to play screen */
{
       add_eilp_to_l2000();
       WX = (int)players[0].PX  - (SCREEN_W/2)-10; /* set window from PX,PY  */
       WY = (int)players[0].PY  - (SCREEN_H/2)-10;
       if (WX < 0) WX = 0;
       if (WX > 1999 - SCREEN_W) WX = 1999 - SCREEN_W;
       if (WY > 1999 - SCREEN_H) WY = 1999 - SCREEN_H;
       if (WY < 0) WY = 0;
   
      if (1)
         {
            int x;

            float inc1 = (0-WX)/steps;
            float inc2 = (0-WY)/steps;
            float inc3 = (2000-SCREEN_W)/steps;
            float inc4 = (2000-SCREEN_H)/steps;
            float inc5 = (mx-0)/steps;
            float inc6 = (my-0)/steps;
            float inc7 = (md*100-SCREEN_W)/steps;
            float inc8 = (md*100-SCREEN_H)/steps;


            float s1 = 0;
            float s2 = 0;
            float s3 = 2000;
            float s4 = 2000;
            float s5 = mx;
            float s6 = my;
            float s7 = md*100;
            float s8 = md*100;
            BITMAP *ht;

            ht = create_bitmap(SCREEN_W, SCREEN_H);

            blit(screen, ht, 0, 0, 0, 0, SCREEN_W, SCREEN_H);

            for (x = 0; x<=steps; x++)
               {
                  stretch_blit(level_2000, ht,(int)s1,(int)s2,(int)s3,(int)s4,(int)s5,(int)s6,(int)s7,(int)s8);

                  blit(ht, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
                  rest((int)(x/steps*5));

                  s1-=inc1;
                  s2-=inc2;
                  s3-=inc3;
                  s4-=inc4;
                  s5-=inc5;
                  s6-=inc6;
                  s7-=inc7;
                  s8-=inc8;

               }
       }
    restore_l2000();
}
void get_new_background()
{
   int p, x, b = 16;
   for (p=0; p<NUM_PLAYERS; p++)
   {
      if ((players[p].active) && (players[p].local_draw))
      {
         // get new background WX and WY
         players[p].WX = (int)players[p].PX  - (players[p].SW/2)-10; // set window from PX, PY
         players[p].WY = (int)players[p].PY  - (players[p].SH/2)-10;
         if (players[p].WX<0) players[p].WX=0;
         if (players[p].WY<0) players[p].WY=0;
         if (players[p].WX > (2000 - players[p].SW ) ) players[p].WX=2000 - players[p].SW;
         if (players[p].WY > (2000 - players[p].SH ) ) players[p].WY=2000 - players[p].SH;

         // draw the frame in the players color
         for (x=1; x<=b; x++)
            rect(scrn_buffer, players[p].SX-x, players[p].SY-x, players[p].SX+players[p].SW+x-1, players[p].SH+players[p].SY+x-1, 8+(p*2)+((16-x)*16) );
         // draw the background 
         blit(level_2000, scrn_buffer, players[p].WX, players[p].WY, players[p].SX, players[p].SY, players[p].SW, players[p].SH);
      }
   }   
}

void draw_bottom_msg()
{
   int a;
   int bc = 15;    // base color
   int nb = 5;     // NUM_BOTTOM_MSG_LINES
   float is = 1.8; // initial size
   float fs = .2;  // final size
   float ypos = SCREEN_H - is*8;
   for (a=0; a< nb; a++)
   {
      extern char b_msg[40][80];
      float aa = (float)a/nb;
      float sc = is-aa*(is-fs);
      float xh = sc*8;
      int ar = (int)(aa*12);
      mtextout_centre(scrn_buffer, b_msg[a], SCREEN_W/2, (int)ypos, sc, sc , bc+(ar*16));
      ypos -= xh;
   }
}

void draw_pop_msg()
{
   extern int item[500][16];
   extern char *pmsg[500];
   extern int pop_msg;

   int c = pop_msg-1;
   int x = SCREEN_W/2;
   int y = 40;

   int len = strlen(pmsg[c]);
   char dt[20][80];
   int row = 0, col = 0;
   int longest_line_len = 1; /* default */
   int num_lines = 0;
   int xpos_c = x;
   int ypos = y;
   int xw;
   int a;
   int tc = item[c][8];
   int fc = item[c][9];
   int px, py, px2, py2;

   for (a=0; a<len+1; a++)
      {
          if (pmsg[c][a] == 13) /* line break */
            {
               row++;
               col=0;
               dt[row][col] = 0; /* in case len = 0 */
            }
         else  /* regular char */
            {
               dt[row][col] = pmsg[c][a];
               if (col > longest_line_len) longest_line_len = col;
               col++;
               dt[row][col] = 0;
            }
      }
   num_lines = row;

   xw = (longest_line_len+1)*4;
   px  = xpos_c-xw-2-8;
   py  = ypos-2-8;
   px2 = xpos_c+xw+8;
   py2 = ypos+(num_lines+1)*8+8;

   a = 7;  /* erase */
   rectfill(scrn_buffer, px+a,py+a,px2-a,py2-a,0);

   for (a=0; a<8; a++) /* frame */
      rect(scrn_buffer, px+a,py+a,px2-a,py2-a,fc+a*16);

   for (row=0; row<=num_lines; row++) /* text */
      textout_centre(scrn_buffer, font, dt[row], xpos_c, ypos+row*8, tc);
}

